#pragma once


#include "stdafx.h"

#include <string>

using namespace std;


class CAIMotorManager;

class CReceivePacket;
class IPacket;


struct MOTOR_POSITION
{
	int x, y;
};

/**	AIMotor ͸    ִ Ŭ.
 *
 *
 *
*/
class CAIMotor 
{
	friend CAIMotorManager;	///< ̷μ   Private   ִ.

	CAIMotor*	m_pParent;	///<  Ͱ Ǿִ .
	
	string	m_sName;		///<  ĺ ̸
	int		m_iID;			///<  ID
	int		m_iBaudRate;	///<  ӵ
	float	m_fResolution;	///<  ܴ  

	int		m_iPos;			///< Ͱ ư ġ ( ϵ  )
	float	m_fAngle;		///< ư ¸  

	int		m_iTorque;		///<  ũ

	int		m_iPGain;		///<  
	int		m_iDGain;		///< ̺ 

	float	m_fOverCurrent;	///< ִ  

	float	m_fCurrent;		///<  

	///<  Ŷ ī...
	int		m_iReceivePacketCounter;

public:
	MOTOR_POSITION	m_Position;

	bool	m_bCapture;
	bool	m_bToSendPacket;


private:
	CAIMotor(int ID);
	CAIMotor(void);
	~CAIMotor(void);

	void SetCurrent( const int& Val );

// ϵ ...
public:
	int GetPosition()	const;		///<  ġ(ϵ ) 
	float GetCurrent()	const;
	int GetMaxCurrent() const;
	int GetGain( int& PGain, int& DGain ) const;


public:
	int GetReceivePacketCounter() const
	{
		return m_iReceivePacketCounter;
	}

	void ResetReceivePacketCounter()
	{
		m_iReceivePacketCounter = 0;
	}

	
	///< ID 
	int GetID()	const
	{
		return m_iID;
	}

	///< ͿԼ  Ŷ ,  Ŷ   ó ϴ Լ.
	void ReceivePacket( IPacket& SendPacket, CReceivePacket& ReceivePacket );



// 3D  ϱ ...
public:
	void	SetParent( CAIMotor* p )
	{
		m_pParent = p;
	}
   
};
