// BaramView.cpp : CBaramView Ŭ 
//

#include "stdafx.h"
#include "Baram2.h"

#include "Baram2Doc.h"
#include "BaramView.h"

#include "AIMotorManager.h"
#include ".\baramview.h"


#ifdef _DEBUG
#define new DEBUG_NEW
#endif

struct D3DVERTEX
{
    D3DXVECTOR3 p;
    D3DXVECTOR3 n;

    static const DWORD FVF;
};
const DWORD D3DVERTEX::FVF = D3DFVF_XYZ | D3DFVF_NORMAL;



// CBaramView

IMPLEMENT_DYNCREATE(CBaramView, CView)

BEGIN_MESSAGE_MAP(CBaramView, CView)
	// ǥ μ Դϴ.
	ON_COMMAND(ID_FILE_PRINT, CView::OnFilePrint)
	ON_COMMAND(ID_FILE_PRINT_DIRECT, CView::OnFilePrint)
	ON_COMMAND(ID_FILE_PRINT_PREVIEW, CView::OnFilePrintPreview)
	ON_WM_KEYDOWN()
	ON_WM_LBUTTONDOWN()
	ON_WM_LBUTTONUP()
	ON_WM_MOUSEMOVE()
	ON_WM_LBUTTONDBLCLK()
END_MESSAGE_MAP()

// CBaramView /Ҹ

CBaramView::CBaramView()
{
	// TODO: ⿡  ڵ带 ߰մϴ.

	g_pBaramView = this;

    m_hwndRenderWindow     = NULL;
    m_hwndRenderFullScreen = NULL;
    m_hWndTopLevelParent   = NULL;

    // Override some CD3DApplication defaults:
  //  m_dwCreationWidth           = 800;
//    m_dwCreationHeight          = 600;


    m_strWindowTitle            = TEXT( "DXTest1" );
    m_d3dEnumeration.AppUsesDepthBuffer   = TRUE;
    m_bStartFullscreen          = false;
    m_bShowCursorWhenFullscreen = false;

    // Create a D3D font using d3dfont.cpp
    m_pFont                     = new CD3DFont( _T("Arial"), 12, D3DFONT_BOLD );
	m_pInfoFont                 = new CD3DFont( _T("Arial"), 9, D3DFONT_BOLD );
    m_bLoadingApp               = TRUE;
    m_pVB                       = NULL;
	m_pBitmap					= NULL;

    m_fWorldRotX                = 0.0f;
    m_fWorldRotY                = 0.0f;

	this->m_d3dSettings.Windowed_Width = 800;
	this->m_d3dSettings.Windowed_Height= 600;

	AIMotorManager.SetDirect3DDevice( m_pd3dDevice );

	m_iSelectedID = -1;
}

CBaramView::~CBaramView()
{
    Cleanup3DEnvironment();
    SAFE_RELEASE( m_pD3D );
    FinalCleanup();
}

BOOL CBaramView::PreCreateWindow(CREATESTRUCT& cs)
{
	// TODO: CREATESTRUCT cs Ͽ ⿡
	// Window Ŭ Ǵ Ÿ մϴ.

	return CView::PreCreateWindow(cs);
}

// CBaramView ׸

void CBaramView::OnDraw(CDC* /*pDC*/)
{
//	CBaram2Doc* pDoc = GetDocument();
//	ASSERT_VALID(pDoc);
//	if (!pDoc)
//		return;

	// TODO: ⿡  Ϳ  ׸ ڵ带 ߰մϴ.
}


// CBaramView μ

BOOL CBaramView::OnPreparePrinting(CPrintInfo* pInfo)
{
	// ⺻ غ
	return DoPreparePrinting(pInfo);
}

void CBaramView::OnBeginPrinting(CDC* /*pDC*/, CPrintInfo* /*pInfo*/)
{
	// TODO: μϱ  ߰ ʱȭ ۾ ߰մϴ.
}

void CBaramView::OnEndPrinting(CDC* /*pDC*/, CPrintInfo* /*pInfo*/)
{
	// TODO: μ   ۾ ߰մϴ.
}



// CBaramView 

#ifdef _DEBUG
void CBaramView::AssertValid() const
{
	CView::AssertValid();
}

void CBaramView::Dump(CDumpContext& dc) const
{
	CView::Dump(dc);
}

CBaram2Doc* CBaramView::GetDocument() const // ׵   ζ ˴ϴ.
{
	ASSERT(m_pDocument->IsKindOf(RUNTIME_CLASS(CBaram2Doc)));
	return (CBaram2Doc*)m_pDocument;
}
#endif //_DEBUG


// CBaramView ޽ ó

//-----------------------------------------------------------------------------
// Name: CBaramView::OneTimeSceneInit()
// Desc: Paired with FinalCleanup().
//       The window has been created and the IDirect3D9 interface has been
//       created, but the device has not been created yet.  Here you can
//       perform application-related initialization and cleanup that does
//       not depend on a device.
//-----------------------------------------------------------------------------
HRESULT CBaramView::OneTimeSceneInit()
{
    // TODO: perform one time initialization

    m_bLoadingApp = FALSE;

	m_pMesh = NULL;

    return S_OK;
}


//-----------------------------------------------------------------------------
// Name: ConfirmDevice()
// Desc: Called during device initialization, this code checks the display device
//       for some minimum set of capabilities
//-----------------------------------------------------------------------------
HRESULT CBaramView::ConfirmDevice( D3DCAPS9* pCaps, DWORD dwBehavior,
                                          D3DFORMAT Format )
{
    /*UNREFERENCED_PARAMETER( pCaps );
    UNREFERENCED_PARAMETER( dwBehavior );
    UNREFERENCED_PARAMETER( Format );
    BOOL bCapsAcceptable;

    // TODO: Perform checks to see if these display caps are acceptable.
    bCapsAcceptable = TRUE;

    if( bCapsAcceptable )         
        return S_OK;
    else
        return E_FAIL;
*/
    if( dwBehavior & D3DCREATE_PUREDEVICE )
        return E_FAIL; // GetTransform doesn't work on PUREDEVICE

    // If this is a TnL device, make sure it supports directional lights
    if( (dwBehavior & D3DCREATE_HARDWARE_VERTEXPROCESSING ) ||
        (dwBehavior & D3DCREATE_MIXED_VERTEXPROCESSING ) )
    {
        if( !(pCaps->VertexProcessingCaps & D3DVTXPCAPS_DIRECTIONALLIGHTS ) )
            return E_FAIL;
    }

}




//-----------------------------------------------------------------------------
// Name: CBaramView::InitDeviceObjects()
// Desc: Paired with DeleteDeviceObjects()
//       The device has been created.  Resources that are not lost on
//       Reset() can be created here -- resources in D3DPOOL_MANAGED,
//       D3DPOOL_SCRATCH, or D3DPOOL_SYSTEMMEM.  Image surfaces created via
//       CreateOffScreenPlainSurface are never lost and can be created here.  Vertex
//       shaders and pixel shaders can also be created here as they are not
//       lost on Reset().
//-----------------------------------------------------------------------------
HRESULT CBaramView::InitDeviceObjects()
{
    // TODO: create device objects
    HRESULT hr;

	AIMotorManager.SetDirect3DDevice( m_pd3dDevice );

	for( int i = 0; i < 25; i++ )
	{
		AIMotorManager.NewMotor( i );
	}

    // Init the font
    hr = m_pFont->InitDeviceObjects( m_pd3dDevice );
    if( FAILED( hr ) )
        return DXTRACE_ERR( "m_pFont->InitDeviceObjects", hr );

    hr = m_pInfoFont->InitDeviceObjects( m_pd3dDevice );
    if( FAILED( hr ) )
        return DXTRACE_ERR( "m_pInfoFont->InitDeviceObjects", hr );

    // Create the vertex buffer
    if( FAILED( hr = m_pd3dDevice->CreateVertexBuffer( 3*2*sizeof(CUSTOMVERTEX),
                                                  0, D3DFVF_CUSTOMVERTEX,
                                                  D3DPOOL_MANAGED, &m_pVB, NULL ) ) )
        return DXTRACE_ERR( "CreateVertexBuffer", hr );

    // Fill the vertex buffer with 2 triangles
    CUSTOMVERTEX* pVertices;

    if( FAILED( hr = m_pVB->Lock( 0, 0, (VOID**)&pVertices, 0 ) ) )
        return DXTRACE_ERR( "Lock", hr );

    // Front triangle
    pVertices[0].position = D3DXVECTOR3( -1.0f, -1.0f,  0.0f );
    pVertices[0].normal   = D3DXVECTOR3(  0.0f,  0.0f, -1.0f );
    pVertices[1].position = D3DXVECTOR3(  0.0f,  1.0f,  0.0f );
    pVertices[1].normal   = D3DXVECTOR3(  0.0f,  0.0f, -1.0f );
    pVertices[2].position = D3DXVECTOR3(  1.0f, -1.0f,  0.0f );
    pVertices[2].normal   = D3DXVECTOR3(  0.0f,  0.0f, -1.0f );

    // Back triangle
    pVertices[3].position = D3DXVECTOR3( -1.0f, -1.0f,  0.0f );
    pVertices[3].normal   = D3DXVECTOR3(  0.0f,  0.0f,  1.0f );
    pVertices[4].position = D3DXVECTOR3(  1.0f, -1.0f,  0.0f );
    pVertices[4].normal   = D3DXVECTOR3(  0.0f,  0.0f,  1.0f );
    pVertices[5].position = D3DXVECTOR3(  0.0f,  1.0f,  0.0f );
    pVertices[5].normal   = D3DXVECTOR3(  0.0f,  0.0f,  1.0f );

    m_pVB->Unlock();


	D3DXCreateBox( m_pd3dDevice, 48.0f, 37.0, 24.7, &m_pMesh, NULL );

	if( !m_pMesh )
		return E_FAIL;


	m_pBitmap = new CSBitmap();
	m_pBitmap->Load( m_pd3dDevice, "Motor.bmp", D3DXCOLOR(1) );

    return S_OK;
}




//-----------------------------------------------------------------------------
// Name: CBaramView::RestoreDeviceObjects()
// Desc: Paired with InvalidateDeviceObjects()
//       The device exists, but may have just been Reset().  Resources in
//       D3DPOOL_DEFAULT and any other device state that persists during
//       rendering should be set here.  Render states, matrices, textures,
//       etc., that don't change during rendering can be set once here to
//       avoid redundant state setting during Render() or FrameMove().
//-----------------------------------------------------------------------------
HRESULT CBaramView::RestoreDeviceObjects()
{
    // TODO: setup render states

    // Setup a material
    D3DMATERIAL9 mtrl;
    D3DUtil_InitMaterial( mtrl, 1.0f, 0.0f, 0.0f );
    m_pd3dDevice->SetMaterial( &mtrl );

    // Set up the textures
    m_pd3dDevice->SetTextureStageState( 0, D3DTSS_COLOROP,   D3DTOP_MODULATE );
    m_pd3dDevice->SetTextureStageState( 0, D3DTSS_COLORARG1, D3DTA_TEXTURE );
    m_pd3dDevice->SetTextureStageState( 0, D3DTSS_COLORARG2, D3DTA_DIFFUSE );
    m_pd3dDevice->SetTextureStageState( 0, D3DTSS_ALPHAOP,   D3DTOP_MODULATE );
    m_pd3dDevice->SetTextureStageState( 0, D3DTSS_ALPHAARG1, D3DTA_TEXTURE );
    m_pd3dDevice->SetTextureStageState( 0, D3DTSS_ALPHAARG2, D3DTA_DIFFUSE );
    m_pd3dDevice->SetSamplerState( 0, D3DSAMP_MINFILTER, D3DTEXF_LINEAR );
    m_pd3dDevice->SetSamplerState( 0, D3DSAMP_MAGFILTER, D3DTEXF_LINEAR );

    // Set miscellaneous render states
    m_pd3dDevice->SetRenderState( D3DRS_DITHERENABLE,   FALSE );
    m_pd3dDevice->SetRenderState( D3DRS_SPECULARENABLE, FALSE );
    m_pd3dDevice->SetRenderState( D3DRS_ZENABLE,        TRUE );
    m_pd3dDevice->SetRenderState( D3DRS_AMBIENT,        0x000F0F0F );

    // Set the world matrix
    D3DXMATRIX matIdentity;
    D3DXMatrixIdentity( &matIdentity );
    m_pd3dDevice->SetTransform( D3DTS_WORLD,  &matIdentity );

    // Set up our view matrix. A view matrix can be defined given an eye point,
    // a point to lookat, and a direction for which way is up. Here, we set the
    // eye five units back along the z-axis and up three units, look at the
    // origin, and define "up" to be in the y-direction.
    D3DXMATRIX matView;
    D3DXVECTOR3 vFromPt   = D3DXVECTOR3( 0.0f, 0.0f, -885.0f );
    D3DXVECTOR3 vLookatPt = D3DXVECTOR3( 0.0f, 0.0f, 0.0f );
    D3DXVECTOR3 vUpVec    = D3DXVECTOR3( 0.0f, 1.0f, 0.0f );
    D3DXMatrixLookAtLH( &matView, &vFromPt, &vLookatPt, &vUpVec );
    m_pd3dDevice->SetTransform( D3DTS_VIEW, &matView );

    // Set the projection matrix
    D3DXMATRIX matProj;
    FLOAT fAspect = ((FLOAT)m_d3dsdBackBuffer.Width) / m_d3dsdBackBuffer.Height;
    D3DXMatrixPerspectiveFovLH( &matProj, D3DX_PI/4, fAspect, 1.0f, 1000.0f );
    m_pd3dDevice->SetTransform( D3DTS_PROJECTION, &matProj );

    // Set up lighting states
    D3DLIGHT9 light;
    D3DUtil_InitLight( light, D3DLIGHT_DIRECTIONAL, -1.0f, -1.0f, 2.0f );
    m_pd3dDevice->SetLight( 0, &light );
    m_pd3dDevice->LightEnable( 0, TRUE );
    m_pd3dDevice->SetRenderState( D3DRS_LIGHTING, TRUE );

    // Restore the font
    m_pFont->RestoreDeviceObjects();
	m_pInfoFont->RestoreDeviceObjects();

//	m_pMesh->

    return S_OK;
}




//-----------------------------------------------------------------------------
// Name: CBaramView::FrameMove()
// Desc: Called once per frame, the call is the entry point for animating
//       the scene.
//-----------------------------------------------------------------------------
HRESULT CBaramView::FrameMove()
{
	static i = 0;
    // TODO: update world

	D3DXMATRIX mat;
    D3DXMATRIX matWorld;
    D3DXMATRIX matRotY;
    D3DXMATRIX matRotX;

    m_fWorldRotY += m_fElapsedTime;

	float fAngleY = 45 * ( PI / 180 ); 
	float fAngleX = 45 * ( PI / 180 ); 
	float fAngleZ = 45 * ( PI / 180 ); 

//    D3DXMatrixRotationX( &matRotX, m_fWorldRotX );    
	D3DXMatrixRotationY( &matRotY, m_fWorldRotY );    

	m_pd3dDevice->GetTransform( D3DTS_WORLD, &mat );
//	D3DXMatrixRotationY( &matRotY, fAngle);

	D3DXMatrixTranslation( &mat, (i++) / 10.0f, 0.0f, 0.0f );
	D3DXMatrixRotationYawPitchRoll( &matWorld, fAngleY * m_fElapsedTime, 0.0f, 0.0f );

//	D3DXMatrixMultiply( &matWorld, &mat, &matWorld );

	D3DXMatrixMultiply( &matWorld, &matRotY, &mat );
//	D3DXMatrixMultiply( &matWorld, &matWorld, &matRotY );




    m_pd3dDevice->SetTransform( D3DTS_WORLD, &matWorld );

    return S_OK;
}
//-----------------------------------------------------------------------------
// Name: CBaramView::Render()
// Desc: Called once per frame, the call is the entry point for 3d
//       rendering. This function sets up render states, clears the
//       viewport, and renders the scene.
//-----------------------------------------------------------------------------
HRESULT CBaramView::Render()
{
    // Clear the viewport
    m_pd3dDevice->Clear( 0L, NULL, D3DCLEAR_TARGET|D3DCLEAR_ZBUFFER,
                         0x000000ff, 1.0f, 0L );

    // Begin the scene
    if( SUCCEEDED( m_pd3dDevice->BeginScene() ) )
    {
        // TODO: render world
        
        // Render the vertex buffer contents
  /*      m_pd3dDevice->SetStreamSource( 0, m_pVB, 0, sizeof(CUSTOMVERTEX) );
        m_pd3dDevice->SetFVF( D3DFVF_CUSTOMVERTEX );
        m_pd3dDevice->DrawPrimitive( D3DPT_TRIANGLELIST, 0, 2 );

*/
		m_pFont->DrawText( 200, 20, D3DCOLOR_ARGB(255,255,255,0), this->m_strFrameStats );

		MotorMap Map = MotorManager::Instance().GetMotorMap();

		char *str1 = "Cap (O)";
		char *str2 = "Cap (X)";
		m_pBitmap->Begin();
		for( MotorMap::iterator iter = Map.begin(); iter != Map.end(); iter++ )
		{
			CAIMotor* pMotor = iter->second;
//			m_pd3dDevice->SetTransform( D3DTS_WORLD, &((*iter).second->GetWorldMatrix()) );
  //          m_pMesh->DrawSubset( 0 );
		
			char temp[255];

			int x = pMotor->m_Position.x;
			int y = pMotor->m_Position.y;

//			sprintf( temp, "ID = %d", iter->first );
			

			if( pMotor->m_bCapture )
				m_pBitmap->Draw( NULL, x, y, 90.0f, 
					D3DXVECTOR3(0,0,0.0f), 0, D3DCOLOR_RGBA( 255, 255, 255, 255 ) );
			else
				m_pBitmap->Draw( NULL, x, y, 90.0f, 
					D3DXVECTOR3(0,0,0.0f), 0, D3DCOLOR_RGBA( 255, 0, 0, 255 ) );



//			m_pInfoFont->DrawText( x + 3, y - 13, D3DCOLOR_RGBA( 255,255,255,255 ), temp );
		}
		m_pBitmap->End();

		for( MotorMap::iterator iter = Map.begin(); iter != Map.end(); iter++ )
		{
			CAIMotor* pMotor = iter->second;
		
			char temp[255];

			int x = pMotor->m_Position.x;
			int y = pMotor->m_Position.y;

			sprintf( temp, "ID = %d", iter->first );
			
			m_pInfoFont->DrawText( x + 13, y + 3, D3DCOLOR_RGBA( 255,255,255,255 ), temp );

//			if( pMotor->m_bCapture )
//				m_pInfoFont->DrawText( x + 3, y + 15, D3DCOLOR_RGBA( 255,255,255,255 ), str1 );
//			else
//				m_pInfoFont->DrawText( x + 3, y + 15, D3DCOLOR_RGBA( 255,255,255,255 ), str2 );

		}
		

        // End the scene.
        m_pd3dDevice->EndScene();
    }

    return S_OK;
}


//-----------------------------------------------------------------------------
// Name: WindowProc()
// Desc: 
//-----------------------------------------------------------------------------
LRESULT CBaramView::WindowProc(UINT message, WPARAM wParam, LPARAM lParam) 
{
    return CView::WindowProc(message, wParam, lParam);
}


//-----------------------------------------------------------------------------
// Name: CBaramView::InvalidateDeviceObjects()
// Desc: Invalidates device objects.  Paired with RestoreDeviceObjects()
//-----------------------------------------------------------------------------
HRESULT CBaramView::InvalidateDeviceObjects()
{
    // TODO: Cleanup any objects created in RestoreDeviceObjects()
    m_pFont->InvalidateDeviceObjects();
	m_pInfoFont->InvalidateDeviceObjects();

    return S_OK;
}




//-----------------------------------------------------------------------------
// Name: CBaramView::DeleteDeviceObjects()
// Desc: Paired with InitDeviceObjects()
//       Called when the app is exiting, or the device is being changed,
//       this function deletes any device dependent objects.  
//-----------------------------------------------------------------------------
HRESULT CBaramView::DeleteDeviceObjects()
{
    // TODO: Cleanup any objects created in InitDeviceObjects()


	m_pMesh->Release();

    m_pFont->DeleteDeviceObjects();
	m_pInfoFont->DeleteDeviceObjects();
    SAFE_RELEASE( m_pVB );

	SAFE_DELETE( m_pFont );
	SAFE_DELETE( m_pInfoFont );

	m_pBitmap->Release();
	SAFE_DELETE( m_pBitmap );

    return S_OK;
}




//-----------------------------------------------------------------------------
// Name: CBaramView::FinalCleanup()
// Desc: Paired with OneTimeSceneInit()
//       Called before the app exits, this function gives the app the chance
//       to cleanup after itself.
//-----------------------------------------------------------------------------
HRESULT CBaramView::FinalCleanup()
{
    // TODO: Perform any final cleanup needed
    // Cleanup D3D font
    SAFE_DELETE( m_pFont );
	SAFE_DELETE( m_pInfoFont );

    return S_OK;
}


//-----------------------------------------------------------------------------
// Name: OnInitialUpdate()
// Desc: When the AppForm object is created, this function is called to
//       initialize it. Here we getting access ptrs to some of the controls,
//       and setting the initial state of some of them as well.
//-----------------------------------------------------------------------------
VOID CBaramView::OnInitialUpdate()
{
    // Update the UI
    CView::OnInitialUpdate();

    // Get the top level parent hwnd
    m_hWndTopLevelParent = GetTopLevelParent()->GetSafeHwnd();

    // Save static reference to the render window
    m_hwndRenderWindow = GetSafeHwnd();

    // Note that for the MFC samples, the device window and focus window
    // are not the same.

	CRect rect;
	GetClientRect( &rect );

	m_dwCreationWidth           = rect.Width();
	m_dwCreationHeight          = rect.Height();

    CD3DApplication::m_hWnd = m_hwndRenderWindow;
    CD3DApplication::m_hWndFocus = m_hwndRenderFullScreen;
    CD3DApplication::Create( AfxGetInstanceHandle() );

    // TODO: Update the UI as needed
}

void CBaramView::OnKeyDown(UINT nChar, UINT nRepCnt, UINT nFlags)
{
	// TODO: ⿡ ޽ ó ڵ带 ߰ /Ǵ ⺻ ȣմϴ.


	
	MotorMap Map = MotorManager::Instance().GetMotorMap();

	MotorMap::iterator iter = Map.begin();


	if( nChar == VK_RIGHT )
	{
//		(*iter).second->Translation( 10.0f, 0.0f, 0.0f );
	}

	if( nChar == VK_LEFT )
	{
//		(*iter).second->Translation( -10.0f, 0.0f, 0.0f );
	}

	if( nChar == VK_UP )
	{
//		(*iter).second->Rotation( 0.0f, 10.0f, 0.0f );
	}

	if( nChar == VK_DOWN )
	{
//		(*iter).second->Rotation( 0.0f, -10.0f, 0.0f );
	}

	__super::OnKeyDown(nChar, nRepCnt, nFlags);
}


BOOL CBaramView::Create( CWnd *pParent )
{
	BOOL bSuccess = ((CWnd*)this)->Create( NULL,
			NULL,
			WS_CHILD | WS_VISIBLE,
			CRect( 0, 0, 0, 0 ),
			pParent, 0, 0 );

	return bSuccess;



}
void CBaramView::OnLButtonDown(UINT nFlags, CPoint point)
{
    HRESULT hr;
/*    D3DXVECTOR3 vPickRayDir;
    D3DXVECTOR3 vPickRayOrig;
	D3DVIEWPORT9 vp;


	D3DXMATRIXA16 matProj;
	hr = m_pd3dDevice->GetTransform( D3DTS_PROJECTION, &matProj );

	m_pd3dDevice->GetViewport( &vp );

	POINT ptCursor;
	GetCursorPos( &ptCursor );
	ScreenToClient( &ptCursor );

	__super::OnLButtonDown(nFlags, point);

	// Compute the vector of the pick ray in screen space
	D3DXVECTOR3 v;
//	v.x =  ( ( ( 2.0f * ptCursor.x ) / m_d3dsdBackBuffer.Width  ) - 1 ) / matProj._11;
//	v.y = -( ( ( 2.0f * ptCursor.y ) / m_d3dsdBackBuffer.Height ) - 1 ) / matProj._22;
//	v.z =  1.0f;

	v.x = ((  (((ptCursor.x-vp.X)*2.0f/vp.Width ) - 1.0f)) - matProj._31 ) / matProj._11;
	 v.y = ((- (((ptCursor.y-vp.Y)*2.0f/vp.Height) - 1.0f)) - matProj._32 ) / matProj._22;
	v.z =  1.0f;

	// Get the inverse of the composite view and world matrix
	D3DXMATRIXA16 matView, matWorld, m;
	m_pd3dDevice->GetTransform( D3DTS_VIEW, &matView );
	m_pd3dDevice->GetTransform( D3DTS_WORLD, &matWorld );

	m = matWorld * matView;
	D3DXMatrixInverse( &m, NULL, &m );

	// Transform the screen space pick ray into 3D space
	vPickRayDir.x  = v.x*m._11 + v.y*m._21 + v.z*m._31;
	vPickRayDir.y  = v.x*m._12 + v.y*m._22 + v.z*m._32;
	vPickRayDir.z  = v.x*m._13 + v.y*m._23 + v.z*m._33;
	vPickRayOrig.x = m._41;
	vPickRayOrig.y = m._42;
	vPickRayOrig.z = m._43;

	// Get the picked triangle
	{
	
        LPD3DXBASEMESH          pMesh = AIMotorManager[0]->GetMesh();
        LPDIRECT3DVERTEXBUFFER9 pVB;
        LPDIRECT3DINDEXBUFFER9  pIB;

        pMesh->GetVertexBuffer( &pVB );
        pMesh->GetIndexBuffer( &pIB );

        WORD*      pIndices;
        D3DVERTEX*    pVertices;

        pIB->Lock( 0, 0, (void**)&pIndices, 0 );
        pVB->Lock( 0, 0, (void**)&pVertices, 0 );

		{
			// Collect only the closest intersection
			BOOL bHit;
			DWORD dwFace;
			FLOAT fBary1, fBary2, fDist;
			D3DXIntersect(pMesh, &vPickRayOrig, &vPickRayDir, &bHit, &dwFace, &fBary1, &fBary2, &fDist, 
				NULL, NULL);
			
			if( bHit )
			{
				int a = 0;
			}
		}

        pVB->Unlock();
        pIB->Unlock();

        pVB->Release();
        pIB->Release();
	}
	*/

	//GetCursorPos( &point );
	//this->ScreenToClient( &point );

	CheckCollision( point );
}

void CBaramView::OnLButtonUp(UINT nFlags, CPoint point)
{
	// TODO: ⿡ ޽ ó ڵ带 ߰ /Ǵ ⺻ ȣմϴ.

	m_iSelectedID = -1;
	__super::OnLButtonUp(nFlags, point);
}

void CBaramView::OnMouseMove(UINT nFlags, CPoint point)
{
	// TODO: ⿡ ޽ ó ڵ带 ߰ /Ǵ ⺻ ȣմϴ.

	if( m_iSelectedID == -1 )
		return;

//	MotorMap Map = AIMotorManager.GetMotorMap();

	AIMotorManager[ m_iSelectedID ]->m_Position.x = point.x;
	AIMotorManager[ m_iSelectedID ]->m_Position.y = point.y;

	__super::OnMouseMove(nFlags, point);
}


int CBaramView::CheckCollision( CPoint point )
{
	int Width = m_pBitmap->GetWidth();
	int Height= m_pBitmap->GetHeight();

	MotorMap Map = AIMotorManager.GetMotorMap();
	MotorMap::iterator iter;

	CRect Rect;
	this->GetWindowRect( &Rect );

	for( iter = Map.begin(); iter != Map.end(); iter++ )
	{

		int a = Rect.Width();
		int b = Rect.Height();

		int posx = iter->second->m_Position.x;
		int posy = iter->second->m_Position.y;

		int poswidth = posx + Width;
		int posheight= posy + Height;

		if( ( point.x < poswidth ) && ( point.x > posx ) )
			if( ( point.y < posheight ) && ( point.y > posy ) )
			{
				m_iSelectedID = iter->first;
				break;
			}
	}

	return m_iSelectedID;
}
void CBaramView::OnLButtonDblClk(UINT nFlags, CPoint point)
{
	// TODO: ⿡ ޽ ó ڵ带 ߰ /Ǵ ⺻ ȣմϴ.

	CheckCollision( point );

	if( m_iSelectedID == -1 )
		return;

	AIMotorManager[ m_iSelectedID ]->m_bCapture = !(AIMotorManager[ m_iSelectedID ]->m_bCapture);

	__super::OnLButtonDblClk(nFlags, point);
}
