#include "OptionManager.h"




/**
	@remarks
	
	@param	const string &Name
	@param	const int Val
	
	@return void 
	
	@author Star.
	@date   2004 7 26   5:19:41
	*/
void COptionManager::AddIntOption( const string &Name, const int Val )
{
	m_IntOption.insert( IntMap::value_type( Name, Val ) );
}




/**
	@remarks
	
	@param	 const string &Name
	@param	const bool Val
	
	@return void 
	
	@author Star.
	@date   2004 7 26   5:19:50
	*/
void COptionManager::AddBoolOption( const string &Name, const bool Val )
{
	m_BoolOption.insert( BoolMap::value_type( Name, Val ) );
}



/**
	@remarks
	
	@param	 const string &Name
	@param	const string& Val
	
	@return void 
	
	@author Star.
	@date   2004 7 26   5:20:00
*/
void COptionManager::AddStringOption( const string &Name, const string& Val )
{
	m_StringOption.insert( StringMap::value_type( Name, Val ) );
}