#include "StdAfx.h"

#include "PacketManager.h"
#include "SerialPort.h"

#include "PacketGenerator.h"
#include "AIMotorManager.h"
#include "AIMotor.h"

#include <afxmt.h>

CPacketManager::CPacketManager(void)
{
//	m_Que.clear();
}

CPacketManager::~CPacketManager(void)
{
}


/**
	@remarks
		Ŷ ø Ʈ , ޴ Ŷ ü   ť  Ѵ.
	
	@param	IPacket &Packet
	
	@return DWORD
	
	@author Star.
	@date   2004 7 13 ȭ  5:36:40
*/
DWORD CPacketManager::Send( IPacket &Packet )
{
	DWORD dwSend = 0;

	if( m_CriticalSection.Lock() )
	{
		// Packet ,  Ŷ  dwSend Ѵ.
		dwSend = g_SerialPort.Send( Packet );

		m_SendQue.push_back( Packet );
	}

	m_CriticalSection.Unlock();
	
	return dwSend;
}



/**
	@remarks
		Ŷ ,  Ŷ  Ŷ  Ŷ Ǵ ,
		   ش. (-_-;)
	
	@param	CReceivePacket Receive
	@return void 
	
	@author Star.
	@date   2004 7 13 ȭ  6:01:52
*/
void CPacketManager::ReceivePacket( CReceivePacket& Receive )
{
	if( m_CriticalSection.Lock() )
	{
		assert( m_SendQue.size() > 0 );

		IPacket Packet = m_SendQue[0];
		m_SendQue.pop_front();

		int ID = Packet.GetMotorID();

		CAIMotor* pMotor = AIMotorManager[ID];
		pMotor->ReceivePacket( Packet, Receive );
	}

	m_CriticalSection.Unlock();
}

/**
	@remarks
		 Ŷ ϴ ť .
	
	@author Star.
	@date   2004 7 25 Ͽ  2:13:50
*/
void CPacketManager::ClearQue()
{
	if( m_CriticalSection.Lock() )
	{
		m_SendQue.clear();
	}
	m_CriticalSection.Unlock();
}