// Page1.cpp :  Դϴ.
//

#include "stdafx.h"
#include "Baram2.h"
#include "Page1.h"

#include "AIMotor.h"
#include "AIMotorManager.h"
#include "MotorNameDialog.h"
#include "MotorNameManager.h"

#include "PacketGenerator.h"
#include "Serialport.h"

#include "ReceivePacket.h"
#include "PacketManager.h"

#include "OptionManager.h"

#include <vector>
#include ".\page1.h"

#define COL_ID		0
#define COL_NAME	1
#define COL_POS		2
#define COL_TORQUE	3
#define COL_CURRENT 4
#define COL_PGAIN	5
#define COL_DGAIN	6

#define TIMER_UPDATE_GRIDCTRL	1


using namespace std;

// CPage1 ȭ Դϴ.

IMPLEMENT_DYNAMIC(CPage1, CPropertyPage )
CPage1::CPage1()
	: CPropertyPage (CPage1::IDD)
	, m_sPosMessage(_T(" ġ"))
	, m_iMotorPos(0)
{
}

CPage1::~CPage1()
{
}

void CPage1::DoDataExchange(CDataExchange* pDX)
{
	CPropertyPage ::DoDataExchange(pDX);
	DDX_Control(pDX, IDC_MSFLEXGRID1, m_GridCtrl);
	DDX_Control(pDX, IDC_PROGRESS1, m_ProgressBar);
	DDX_Control(pDX, IDC_PAGE1STATUS, m_Status);
	DDX_Control(pDX, IDC_PROGRESS_STATUS_LABEL, m_ProgressStatusLabel);

	DDX_Control(pDX, IDC_SCANID, m_btnScanID);

	DDX_Text(pDX, IDC_MOTORPOSMESSAGE, m_sPosMessage);
	DDX_Text(pDX, IDC_MOTORPOS, m_iMotorPos );
	DDX_Control(pDX, IDC_POSSLIDER, m_PosSlider);
}


BEGIN_MESSAGE_MAP(CPage1, CPropertyPage)
	ON_BN_CLICKED(IDC_SCANID, OnBnClickedScanid)
	ON_BN_CLICKED(IDC_SETPOSALL, OnBnClickedSetposall)
	ON_BN_CLICKED(IDC_SCANALL, OnBnClickedScanall)

	ON_UPDATE_COMMAND_UI(ID_IDEDIT, OnUpdateIdedit)
	ON_COMMAND(ID_IDEDIT, OnIdedit)	

	//  Ŷ ޾   ڰ  ޼ ó
	ON_MESSAGE( WM_RECEIVE_ANSWER_PACKET, OnReceiveAnswerPacket )
	ON_WM_TIMER()
	ON_BN_CLICKED(IDC_GETPOSALL, OnBnClickedGetposall)
	ON_NOTIFY(NM_RELEASEDCAPTURE, IDC_POSSLIDER, OnNMReleasedcapturePosslider)
END_MESSAGE_MAP()


// CPage1 ޽ óԴϴ.

BOOL CPage1::OnInitDialog()
{
	CPropertyPage::OnInitDialog();

	InitGridCtrl();
	UpdateGridCtrl();

	SetTimer( TIMER_UPDATE_GRIDCTRL, 50, NULL );

	m_PosSlider.SetRange( 0, 254, TRUE );

	return TRUE;  // return TRUE unless you set the focus to a control
	// : OCX Ӽ  FALSE ȯؾ մϴ.
}



/**
	@remarks
		 ϴ ڷ    ͵ ã ο ͵ Ѵ. ( ID Scan )

	ID Scanϴ  0 30  鼭 شǴ ȣ  Ϳ
	GetPositionŶ . ð ٸ Ŀ  Ŷ   ȣ ID  ʹ
	 Ǿִ ̰,  Ŷ  ϸ  ʹ   ̴.
	
	@return void 
	@date 2004 7 1   1:48:19
*/
void CPage1::OnBnClickedScanid()
{
	// TODO: ⿡ Ʈ ˸ ó ڵ带 ߰մϴ.

	g_SerialPort.ClearBuffer();


	MotorManager::Instance().Reset();

	InitProgressBar( 30 );


	SetStatusMessage( "ID ĵϴ ..." );

	for( int i = 0; i < 31; i++ )
	{
		PacketManager.ClearQue();

		UpdateProgressBar(); 

		// AIMotor ü  ,  ü ID  ͷ
		// ġ о Ŷ .
		// ü ϴ , AIͷ  Ŷ Ŷ
		//  ü ٷ ޵Ǳ ̴.
		CAIMotor *pMotor = MotorManager::Instance().NewMotor( i );
		PacketManager.Send( CGetPosition( i ), false );

		//  Ŷ    ֵ ణ ̸ ش.
		g_SerialPort.Delay( 30 );
		
		//  ü  ִ ġ о´.
		int Pos = pMotor->GetPosition();

		//  ID  Ͱ Ǿ ִٸ ġ 0~254   ̴.
		// CAIMotor ڴ m_iPos  -1 ʱȭϱ , Pos  
		//  ƴ 쿡 Ͱ   ̴.
		if( Pos < 0 )
		{
			AIMotorManager.DeleteMotor( i );
			continue;
		}
	}

	g_SerialPort.Delay( 30 );

	PacketManager.ClearQue();
	g_SerialPort.ClearBuffer();

	CString str;

	str.Format( "ID ĵ . - %d Ͱ ĵǾϴ.", AIMotorManager.GetMotorMap().size() );

	SetStatusMessage( str );

	UpdateGridCtrl();

}



/**
	@remarks
		ϵ   ġ Էµ  Ѵ.	
	
	@return void 
	
	@author Star.
*/
void CPage1::OnBnClickedSetposall()
{
	CString szTemp;

	InitProgressBar( m_GridCtrl.GetRows() - 1 + 40 );
	SetStatusMessage( " ġ  Ŷ  .." );

	PacketManager.ClearQue();
	g_SerialPort.ClearBuffer();

	for( int i = 1; i < this->m_GridCtrl.GetRows(); i++ )
	{
		int ID	 = m_GridCtrl.GetInt( i, COL_ID );
		int	 Pos = m_GridCtrl.GetInt( i, COL_POS );

		//CAIMotor *pMotor = MotorManager::Instance().GetMotor( ID );
		CAIMotor *pMotor = AIMotorManager[ID];

		PacketManager.Send( CSetPosition( ID, Pos, 0 ), false );

//		g_SerialPort.Delay( 1 );
		UpdateProgressBar();
	}


	for( int i = 0; i < 40; i++ )
	{
        g_SerialPort.Delay( 15 );
		UpdateProgressBar();
	}

	SetStatusMessage( " ġ  Ŷ  ½ϴ." );

	g_SerialPort.ClearBuffer();
	PacketManager.ClearQue();

	UpdateGridCtrl();

	
}



/**
	@remarks
		AI ü ִ  ð Ÿִ Լ.
	
	@return void 
	@date 2004 7 1   1:47:39
*/
void CPage1::UpdateGridCtrl()
{
	long Row = 1;
	
	MotorMap Map= MotorManager::Instance().GetMotorMap();

	// ׸ Row  ֻrow fixed row    + 1 ȴ.
	m_GridCtrl.SetRows( Map.size() + 1 );

	// ϵ Ͱ  return
	if( Map.size() < 1 )
		return;
    
	MotorMap::iterator iter = Map.begin();

	CAIMotor *pMotor = NULL;


	for( ; iter != Map.end(); iter++ )
	{	
		pMotor = iter->second;

		int ID = iter->first;

		m_GridCtrl.SetInt( Row, COL_ID, ID );
		
		//  ̸
		m_GridCtrl.SetString( Row, COL_NAME, MotorNameManager[ID].c_str() );

		//  ġ
		m_GridCtrl.SetInt( Row, COL_POS, pMotor->GetPosition() );

		int PGain, DGain;

		iter->second->GetGain( PGain, DGain );

		//  P-GAIN
		m_GridCtrl.SetInt( Row, COL_PGAIN, PGain );

		//  D-Gain
		m_GridCtrl.SetInt( Row, COL_DGAIN, DGain );

		//  
		m_GridCtrl.SetInt( Row, COL_CURRENT, pMotor->GetCurrent() );



		Row++;
	}

}



/**
	@remarks
		ϵ   ġ, , GAIN  о´. ( ϵκ.. )	
	@return void 
	@date 2004 7 1   4:49:50
*/
void CPage1::OnBnClickedScanall()
{
	long Row = 1;
	
	MotorMap Map= MotorManager::Instance().GetMotorMap();

	// ϵ Ͱ  return
	if( Map.size() < 1 )
		return;
    
	MotorMap::iterator iter = Map.begin();


	for( ; iter != Map.end(); iter++ )
	{	
		int ID = (*iter).first;
		CAIMotor* pMotor = iter->second;

		

		CReceivePacket Data;

//		g_SerialPort.ClearBuffer();
//		g_SerialPort.Send( CGetPosition( ID ) );
		g_SerialPort.Delay( 20 );

		bool bSuccess = true;// = g_SerialPort.Read( Data );
		if( bSuccess )
		{
//			pMotor->SetPosition( (int)Data[1], 0, false );
		}


//		g_SerialPort.Send( CGetGain( ID ) );
		g_SerialPort.Delay( 20 );


//		bSuccess = g_SerialPort.Read( Data );

		if( bSuccess )
		{
//			pMotor->SetGain( (int)Data[0], (int)Data[1], false );
		}

//		g_SerialPort.Send( CGetMaxCurrent( ID ) );
	}

/*
	iter = Map.begin();

	for( ; iter != Map.end(); iter++ )
	{	
        CReceivePacket Data;
		CAIMotor* pMotor = iter->second;

		g_SerialPort.Read( Data ); //  ġ;
		pMotor->SetPosition( (int)Data[0], 0, false ); // Ϳ  .

		g_SerialPort.Read( Data ); // P,D -  Gain
		pMotor->SetGain( (int)Data[1], (int)Data[0], false );
	}
*/
	UpdateGridCtrl();

	g_SerialPort.ClearBuffer();
		
}

void CPage1::OnIdedit()
{
	CMotorNameDialog Dialog;

	Dialog.DoModal();

	UpdateGridCtrl();

	// TODO: ⿡  ó ڵ带 ߰մϴ.
}


void CPage1::OnUpdateIdedit(CCmdUI *pCmdUI)
{
	// TODO: ⿡  Ʈ UI ó ڵ带 ߰մϴ.
}


/**
	@remarks
		AIͰ  Ŷ ޾    ð Ÿ  Լ.
	
	@param	WPARAM wParam
	@param	LPARAM lParam
	
	@return LRESULT 
	
	@author Star.
	@date   2004 7 13 ȭ  3:46:33
*/
LRESULT CPage1::OnReceiveAnswerPacket( WPARAM wParam, LPARAM lParam )
{
	UpdateGridCtrl();

	return TRUE;
}




/**
	@remarks
		 ¸ ǥϰ, ̾α Ʈ.
	
	@param	CString Msg
	
	@return void 
	
	@author Star.
	@date   2004 7 13 ȭ  4:01:24
*/
void CPage1::SetStatusMessage( CString Msg )
{
	m_Status.SetWindowText( Msg );

	Invalidate( FALSE );
}



/**
	@remarks
		Progress Bar  0 Max  , ó  0 ش.
	
	@param  int Max	
				ProgressBar Range( 0 ~ Max )  Max.
	
	@return void 
	
	@author Star.
	@date   2004 7 13 ȭ  4:25:16
*/
void CPage1::InitProgressBar( int Max )
{
	m_ProgressBar.SetRange( 0, Max );
	m_ProgressBar.SetPos( 0 );	
}



/**
	@remarks
		ProgressBar  1 Ŵ.
	
	
	@return void 
	
	@author Star.
	@date   2004 7 13 ȭ  4:27:19
*/
void CPage1::UpdateProgressBar()
{
	m_ProgressBar.OffsetPos( 1 );
}


void CPage1::InitGridCtrl()
{
	m_GridCtrl.SetString( 0, COL_ID,	"ID" );
	m_GridCtrl.SetString( 0, COL_NAME,	"̸" );
	m_GridCtrl.SetString( 0, COL_POS,	"ġ" );
	m_GridCtrl.SetString( 0, COL_TORQUE,"ũ" );
	m_GridCtrl.SetString( 0, COL_CURRENT,"" );
	m_GridCtrl.SetString( 0, COL_PGAIN,	 "P-Gain" );
	m_GridCtrl.SetString( 0, COL_DGAIN,	 "D-Gain" );

	m_GridCtrl.SetColWidth( COL_NAME, 2500 );
}
void CPage1::OnTimer(UINT nIDEvent)
{
	// TODO: ⿡ ޽ ó ڵ带 ߰ /Ǵ ⺻ ȣմϴ.
	if( nIDEvent == TIMER_UPDATE_GRIDCTRL )
	{
		if( OptionManager.GetBoolOption( "MONITORING" ) )
		{
			UpdateGridCtrl();

			MotorMap Map= MotorManager::Instance().GetMotorMap();

			// ϵ Ͱ  return
			if( Map.size() < 1 )
				return;

			MotorMap::iterator iter = Map.begin();
			CAIMotor* pMotor =  NULL;

			for( ; iter != Map.end(); iter++ )
			{	
				int ID = iter->first;
				pMotor = iter->second;

				//PacketManager.Send( CSetPosition( ID, pMotor->GetPosition(), 0 ) );
				PacketManager.Send( CSetPosition( ID, 127, 0 ) );
				//PacketManager.Send( CGetPosition( ID ) );
			}
		}
	}

	CPropertyPage::OnTimer(nIDEvent);
}

void CPage1::OnBnClickedGetposall()
{

	CString szTemp;

	AIMotorManager.SendGetPositionAll();

	SetStatusMessage( " ġ б Ŷ  ½ϴ." );

	g_SerialPort.Delay( 30 );

	UpdateGridCtrl();
	
    g_SerialPort.ClearBuffer();
	PacketManager.ClearQue();

	InitProgressBar( AIMotorManager.GetMotorMap().size() );

	MotorMap Map = AIMotorManager.GetMotorMap();

	SetStatusMessage( " ġ о ..." );

	for( MotorMap::iterator iter = Map.begin(); iter != Map.end(); iter++ )
	{
		int ID = iter->first;

		PacketManager.Send( CGetPosition( ID ), false );

		//  Ŷ    ֵ ణ ̸ ش.
		g_SerialPort.Delay( 40 );

		UpdateProgressBar(); 
	}

	g_SerialPort.Delay( 40 );
	g_SerialPort.ClearBuffer();

	PacketManager.ClearQue();

	SetStatusMessage( " ͵  ġ оԽϴ." );

	UpdateGridCtrl();
}

void CPage1::OnNMReleasedcapturePosslider(NMHDR *pNMHDR, LRESULT *pResult)
{
	int Sel = m_GridCtrl.GetRow();
	int ID = m_GridCtrl.GetInt( Sel, 0 );

	m_iMotorPos = m_PosSlider.GetPos();

	PacketManager.Send( CSetPosition( ID, m_iMotorPos, 0 ), false );

	UpdateData( FALSE );
	*pResult = 0;
}

BEGIN_EVENTSINK_MAP(CPage1, CPropertyPage)
	ON_EVENT(CPage1, IDC_MSFLEXGRID1, DISPID_CLICK, ClickMsflexgrid1, VTS_NONE)
END_EVENTSINK_MAP()

void CPage1::ClickMsflexgrid1()
{
	int Sel = m_GridCtrl.GetRow();
	int ID = m_GridCtrl.GetInt( Sel, 0 );

	m_sPosMessage .Format( "%d ġ:", ID );
	m_iMotorPos = AIMotorManager[ID]->GetPosition();

	m_PosSlider.SetPos( m_iMotorPos );

	UpdateData( FALSE );

	// TODO: ⿡ ޽ ó ڵ带 ߰մϴ.
}

BOOL CPage1::OnSetActive()
{
	// TODO: ⿡ Ưȭ ڵ带 ߰ /Ǵ ⺻ Ŭ ȣմϴ.
	InitGridCtrl();
	UpdateGridCtrl();

	return CPropertyPage::OnSetActive();
}
