// Page2.cpp :  Դϴ.
//

#include "stdafx.h"
#include "Baram2.h"
#include "Page2.h"

#include "AIMotor.h"
#include "AIMotorManager.h"
#include "MotorNameManager.h"

#include "PacketGenerator.h"
#include "Serialport.h"

#include "OptionManager.h"

#include "PacketManager.h"
#include ".\page2.h"

#include <algorithm>


// CPage2 ȭ Դϴ.

IMPLEMENT_DYNAMIC(CPage2, CPropertyPage)
CPage2::CPage2()
	: CPropertyPage(CPage2::IDD)
	, m_strMotionName(_T(""))
	, m_strAuthor(_T(""))
	, m_iSpeed(0)
{
	OptionManager.AddBoolOption( "START_CAPTURE", false );

	m_bCheckChangedMotor = true;
}

CPage2::~CPage2()
{
}

void CPage2::DoDataExchange(CDataExchange* pDX)
{
	CPropertyPage::DoDataExchange(pDX);

	DDX_Text(pDX, IDC_MOTIONAUTHORNAME, m_strAuthor);
	DDX_Text(pDX, IDC_MOTIONNAME, m_strMotionName);
	DDX_Text(pDX, IDC_SPEED, m_iSpeed );

	DDX_Control(pDX, IDC_CHANGEDMOTORS, m_GridChanged );
	DDX_Control(pDX, IDC_BACKUPLIST, m_GridBackupList );
	DDX_Control(pDX, IDC_BACKUPDATA, m_GridBackupData );
	DDX_Control(pDX, IDC_MOTIONLIST, m_GridMotionList );

	DDX_Control(pDX, IDC_STARTCAP, m_btnStartCapture);
	DDX_Control(pDX, IDC_STARTCAP2, m_btnStartCapture2);
	DDX_Control(pDX, IDC_STOPCAP, m_btnStopCapture);
	DDX_Control(pDX, IDC_RUNTEMPMOTION, m_btnRunTempMotion);
	DDX_Control(pDX, IDC_SETPOSBACK, m_btnSetBackPosition);
	DDX_Control(pDX, IDC_BACKUP, m_btnBackup);
	DDX_Control(pDX, IDC_RESTORE, m_btnRestore);
	DDX_Control(pDX, IDC_BACKUPDELETE, m_btnDeleteBackup);
	DDX_Control(pDX, IDC_RUNTEMPMOTION2, m_btnRunTempMotion2);
	DDX_Control(pDX, IDC_RUNBACKUPMOTION, m_btnRunBackupMotion);
	DDX_Control(pDX, IDC_SAVEMOTION, m_btnSaveMotion);
	DDX_Control(pDX, IDC_PROGRESS1, m_ProgressBar);
	DDX_Control(pDX, IDC_RUNSINGLEMOTION, m_btnRunSingleMotion);
	DDX_Control(pDX, IDC_REMOVESINGLEMOTION, m_btnRemoveSingleMotion);
	DDX_Control(pDX, IDC_EDITSINGLEMOTION, m_btnEditSingleMotion);
	DDX_Control(pDX, IDC_CAPALL, m_btnCapAll);
	DDX_Control(pDX, IDC_DONTCAPALL, m_btnDontCapAll);
}


BEGIN_MESSAGE_MAP(CPage2, CPropertyPage)
	ON_BN_CLICKED(IDC_STARTCAP, OnBnClickedStartcap)
	ON_BN_CLICKED(IDC_STOPCAP, OnBnClickedStopcap)
	ON_BN_CLICKED(IDC_RUNTEMPMOTION, OnBnClickedRuntempmotion)
	ON_BN_CLICKED(IDC_SETPOSBACK, OnBnClickedSetposback)
	ON_BN_CLICKED(IDC_BACKUP, OnBnClickedBackup)
	ON_BN_CLICKED(IDC_BACKUPDELETE, OnBnClickedBackupdelete)
	ON_BN_CLICKED(IDC_RESTORE, OnBnClickedRestore)
	ON_BN_CLICKED(IDC_SAVEMOTION, OnBnClickedSavemotion)
	ON_BN_CLICKED(IDC_RUNTEMPMOTION2, OnBnClickedRuntempmotion2)
	ON_BN_CLICKED(IDC_EDITSINGLEMOTION, OnBnClickedEditsinglemotion)
	ON_BN_CLICKED(IDC_RUNSINGLEMOTION, OnBnClickedRunsinglemotion)
	ON_BN_CLICKED(IDC_SETSPEED, OnBnClickedSetspeed)
	ON_BN_CLICKED(IDC_CAPALL, OnBnClickedCapall)
	ON_BN_CLICKED(IDC_DONTCAPALL, OnBnClickedDontcapall)
	ON_BN_CLICKED(IDC_STARTCAP2, OnBnClickedStartcap2)
END_MESSAGE_MAP()


// CPage2 ޽ óԴϴ.

int Pos[31];

void CPage2::OnBnClickedStartcap()
{
	MotorMap Map = AIMotorManager.GetMotorMap();

	m_bCheckChangedMotor = true;

	InitProgressBar( Map.size() );	

//	g_SerialPort.ClearBuffer();
//	PacketManager.ClearQue();

	AIMotorManager.SendGetPositionAll();
	g_SerialPort.Delay( 30 );

	m_LastPosition.clear();

	g_SerialPort.ClearBuffer();
	PacketManager.ClearQue();

	///  ŭ   ġ о Ŷ .
	for( MotorMap::iterator iter = Map.begin(); iter != Map.end(); iter++ )
	{
		int ID = iter->first;
		CAIMotor *pMotor = iter->second;

		UpdateProgressBar(); 

		if( pMotor->m_bCapture )
		{
			PacketManager.Send( CGetPosition( ID ), false );

			//  Ŷ    ֵ ణ ̸ ش.
			g_SerialPort.Delay( 40 );
		}
	}

	g_SerialPort.Delay( 40 );

	g_SerialPort.ClearBuffer();
	PacketManager.ClearQue();

	/// о ġ Ѵ.
	for( MotorMap::iterator iter = Map.begin(); iter != Map.end(); iter++ )
	{
		int ID = iter->first;
		CAIMotor* pMotor = iter->second;

		LASTPOSITION Temp;

		Temp.ID = ID;
		Temp.Pos = pMotor->GetPosition();

		m_LastPosition.push_back( Temp );

		UpdateProgressBar(); 
	}
}

LRESULT CPage2::WindowProc(UINT message, WPARAM wParam, LPARAM lParam)
{
	// TODO: ⿡ Ưȭ ڵ带 ߰ /Ǵ ⺻ Ŭ ȣմϴ.

	return CPropertyPage::WindowProc(message, wParam, lParam);
}


void CPage2::InitGridCtrl()
{
	int ChangedWidth1 = 0, ListWidth1 = 0, DataWidth1 = 0;
	int ChangedWidth2 = 0, ListWidth2 = 0, DataWidth2 = 0;
	CRect rect;


	m_GridChanged.GetWindowRect( &rect );
	ChangedWidth1 = rect.Width() / m_GridChanged.GetCols();

	m_GridBackupList.GetWindowRect( &rect );
	ListWidth1 = rect.Width() / m_GridBackupList.GetCols();

	m_GridBackupData.GetWindowRect( &rect );
	DataWidth1 = rect.Width() / m_GridBackupData.GetCols();

	m_GridChanged.SetColWidth( 0, ( 20 * 15 ) ); 
	m_GridChanged.SetColWidth( 1, ( 80 * 15 ) );
	m_GridChanged.SetColWidth( 2, ( 55 * 15 ) );
	m_GridChanged.SetColWidth( 3, ( 40 * 15 ) );

	m_GridBackupData.SetColWidth( 0, ( 20 * 15 ) ); 
	m_GridBackupData.SetColWidth( 1, ( 90 * 15 ) );
	m_GridBackupData.SetColWidth( 2, ( 55 * 15 ) );
	m_GridBackupData.SetColWidth( 2, ( 45 * 15 ) );

	m_GridBackupList.SetColWidth( 0, ( 35 * 15 ) ); 

/*	for( int i = 0; i < m_GridChanged.GetCols(); i++ )
	{
		m_GridChanged.SetColWidth( i, ChangedWidth * 15 );
	}

	for( int i = 0; i < m_GridBackupList.GetCols(); i++ )
	{
		m_GridBackupList.SetColWidth( i, ListWidth * 15 );
	}

	for( int i = 0; i < m_GridBackupData.GetCols(); i++ )
	{
		m_GridBackupData.SetColWidth( i, DataWidth * 15 );
	}
*/


	m_GridChanged.SetString( 0, 0, "ID" );
	m_GridChanged.SetString( 0, 1, "̸" );
	m_GridChanged.SetString( 0, 2, "ġ" );
	m_GridChanged.SetString( 0, 3, "ӵ" );

	m_GridBackupData.SetString( 0, 0, "ID" );
	m_GridBackupData.SetString( 0, 1, "̸" );
	m_GridBackupData.SetString( 0, 2, "ġ" );
	m_GridBackupData.SetString( 0, 3, "ӵ" );

	m_GridBackupList.SetString( 0, 0, "No." );


	m_GridMotionList.SetString( 0, 0, "No." );
	m_GridMotionList.SetString( 0, 1, " ̸" );
	m_GridMotionList.SetString( 0, 2, "" );

	m_GridMotionList.GetWindowRect( &rect );

	m_GridMotionList.SetColWidth( 0, 70 * 15 );
	m_GridMotionList.SetColWidth( 1, ( rect.Width() - 190 ) * 15 );
	m_GridMotionList.SetColWidth( 2, 95 * 15 );
}


BOOL CPage2::OnInitDialog()
{
	CPropertyPage::OnInitDialog();

	InitGridCtrl();

	return TRUE;  // return TRUE unless you set the focus to a control
	// : OCX Ӽ  FALSE ȯؾ մϴ.
}


/// ĸ  Ŭ.
void CPage2::OnBnClickedStopcap()
{
	MotorMap Map = AIMotorManager.GetMotorMap();

	if( m_LastPosition.size() < 1 )
	{
		MessageBox( "ۺ " );
		return;
	}

	InitProgressBar( Map.size() );	

	vector<LASTPOSITION> CurrentPosition;


	//  ġ о 
	{
		g_SerialPort.ClearBuffer();
		PacketManager.ClearQue();

		///  ŭ   ġ о Ŷ .
		for( MotorMap::iterator iter = Map.begin(); iter != Map.end(); iter++ )
		{
			int ID = iter->first;
			CAIMotor *pMotor = iter->second;

			UpdateProgressBar(); 

			if( pMotor->m_bCapture )
			{
				PacketManager.Send( CGetPosition( ID ), false );

				//  Ŷ    ֵ ణ ̸ ش.
				g_SerialPort.Delay( 40 );
			}
		}

		g_SerialPort.Delay( 40 );

		g_SerialPort.ClearBuffer();
		PacketManager.ClearQue();
	}

	// о ġ ϴ 
	{		
		// о ġ Ѵ.
		for( MotorMap::iterator iter = Map.begin(); iter != Map.end(); iter++ )
		{
			int ID = iter->first;
			CAIMotor* pMotor = iter->second;

			LASTPOSITION temp;

			temp.ID = ID;
			temp.Pos = pMotor->GetPosition();

			CurrentPosition.push_back( temp );

			UpdateProgressBar(); 
		}
		

		//  ۾  κ ...  ǰ .
/*		{
			int Count = rand() % 20;

			for( MotorMap::iterator iter = Map.begin(); iter != Map.end(); iter++ )
			{
				LASTPOSITION temp;

				temp.ID = iter->first;
				temp.Pos = rand() % 255;

				if( ( rand() % 255 ) < 80 )
					CurrentPosition.push_back( temp );
				else
				{
					temp.Pos = -1;
					CurrentPosition.push_back( temp );
				}
			}
		}

*/
	}


	// о ġ    
	{
		m_WorkingMotion.Clear();

		if( m_bCheckChangedMotor == true )
		{
			int DiffCount = 0;	
			for( int i = 0; i < Map.size(); i++ )
			{
				if( !(CurrentPosition[i] == m_LastPosition[i]) )
				{
					CFrame Frame( CurrentPosition[i].ID, CurrentPosition[i].Pos );

					m_WorkingMotion.AddFrame( Frame );

					DiffCount++;			
				}
			}

			if( DiffCount == 0 )
			{
				AfxMessageBox( "ġ ٲ ͵ ϴ." );
			}
		}
		else
		{
			for( int i = 0; i < Map.size(); i++ )
			{
				CFrame Frame( CurrentPosition[i].ID, CurrentPosition[i].Pos, 3 );

				m_WorkingMotion.AddFrame( Frame );
			}
		}
	}

	UpdateChangedMotorsGrid();
}

/// ĸ ӽ  ÷.
void CPage2::OnBnClickedRuntempmotion()
{
	CString szTemp;

	InitProgressBar( m_GridChanged.GetRows() - 1 + 40 );

	for( int i = 0; i < m_GridChanged.GetRows() - 1; i++ )
	{
		m_WorkingMotion[i].m_iID = m_GridChanged.GetInt( i + 1, 0 );
		m_WorkingMotion[i].m_iPos = m_GridChanged.GetInt( i + 1, 2 );
		m_WorkingMotion[i].m_iSpeed = m_GridChanged.GetInt( i + 1, 3 );
	}

	/*
	PacketManager.ClearQue();
	g_SerialPort.ClearBuffer();

	for( int i = 1; i < this->m_GridChanged.GetRows(); i++ )
	{
		int ID   = m_GridChanged.GetInt( i, 0 );
		int Pos  = m_GridChanged.GetInt( i, 2 );
		int Speed= m_GridChanged.GetInt( i, 3 );

		//CAIMotor *pMotor = MotorManager::Instance().GetMotor( ID );
		CAIMotor *pMotor = AIMotorManager[ID];

		PacketManager.Send( CSetPosition( ID, Pos, Speed ), false );

		g_SerialPort.Delay( 1 );
		UpdateProgressBar();
	}


	for( int i = 0; i < 40; i++ )
	{
        g_SerialPort.Delay( 15 );
		UpdateProgressBar();
	}

	g_SerialPort.ClearBuffer();
	PacketManager.ClearQue();*/

	m_WorkingMotion.Run();
}

/// ĳϱ  · .
void CPage2::OnBnClickedSetposback()
{
	CString szTemp;

	InitProgressBar( m_LastPosition.size() - 1 + 40 );

	PacketManager.ClearQue();
	g_SerialPort.ClearBuffer();

	for( int i = 0;i < m_LastPosition.size(); i++ )
	{
		int ID	 = m_LastPosition[i].ID;
		int	 Pos = m_LastPosition[i].Pos;

		//CAIMotor *pMotor = MotorManager::Instance().GetMotor( ID );
		CAIMotor *pMotor = AIMotorManager[ID];

		PacketManager.Send( CSetPosition( ID, Pos, 0 ), false );

		g_SerialPort.Delay( 1 );
		UpdateProgressBar();
	}


	for( int i = 0; i < 40; i++ )
	{
        g_SerialPort.Delay( 15 );
		UpdateProgressBar();
	}

	g_SerialPort.ClearBuffer();
	PacketManager.ClearQue();
}

///  ͸ .
void CPage2::OnBnClickedBackup()
{
	// TODO :  ̿ϼ...!! ߿ ۾ؾ  !!
	
	//m_BackupMotion.push_back( m_WorkingMotion );

	//this->UpdateBackupListGrid();

	MessageBox( "  ؿ!!!" );
}

///   .
void CPage2::OnBnClickedBackupdelete()
{
	//m_BackupMotion.erase( find( m_BackupMotion.begin(), m_BackupMotion.end(), m_BackupMotion[ m_GridBackupList.GetRow() ] ) );	

	m_BackupMotion.erase( &m_BackupMotion[ m_GridBackupList.GetRow() - 1 ] );

	this->UpdateBackupListGrid();
}

///  ͷ .
void CPage2::OnBnClickedRestore()
{
	// TODO: ⿡ Ʈ ˸ ó ڵ带 ߰մϴ.
}

///   
void CPage2::OnBnClickedSavemotion()
{
	// TODO: ߿..!    ڵؾ!

	this->UpdateData();

	int count = m_WorkingMotion.GetFrameCount();

	if( count < 1 )
	{
		MessageBox( "ϸ 峭?   ڳ!!!" );
		return;
	}

	for( int i = 0; i < m_GridChanged.GetRows() - 1; i++ )
	{
		m_WorkingMotion[i].m_iID = m_GridChanged.GetInt( i + 1, 0 );
		m_WorkingMotion[i].m_iPos = m_GridChanged.GetInt( i + 1, 2 );
		m_WorkingMotion[i].m_iSpeed = m_GridChanged.GetInt( i + 1, 3 );
	}

//	int iSel = MessageBox( "ϸ  ̸ ۼڴ ߿   ϴ.\n"
//		"  ̸   ִٸ  ˴ϴ.\n"
//		"մϱ?", "", MB_ICONQUESTION | MB_YESNO );

	m_WorkingMotion.SetName( m_strMotionName.GetBuffer() );
	m_WorkingMotion.SetAuthor( m_strAuthor.GetBuffer() );

	CMotion* temp = new CSingleMotion( m_WorkingMotion );

	bool bResult = MotionManager.AddMotion( m_strMotionName.GetBuffer(), temp );

	if( bResult == false )
	{
		if( MessageBox( " ̸   ̹ ֽϴ. \n"
			"ðڽϱ? ( ʹ  ϴ.)", "", MB_ICONQUESTION | MB_YESNO ) == IDYES )
		{
			MotionManager.AddMotion( m_strMotionName.GetBuffer(), temp, true );
		}
		else
			delete temp;
	}


	SelChangeChangedmotors();
	UpdateMotionListGrid();		
}



/**
	@remarks
		Progress Bar  0 Max  , ó  0 ش.
	
	@param  int Max	
				ProgressBar Range( 0 ~ Max )  Max.
	
	@return void 
	
	@author Star.
	@date   2004 7 13 ȭ  4:25:16
*/
void CPage2::InitProgressBar( int Max )
{
	m_ProgressBar.SetRange( 0, Max );
	m_ProgressBar.SetPos( 0 );	
}



/**
	@remarks
		ProgressBar  1 Ŵ.
	
	
	@return void 
	
	@author Star.
	@date   2004 7 13 ȭ  4:27:19
*/
void CPage2::UpdateProgressBar()
{
	m_ProgressBar.OffsetPos( 1 );
}

//  ǵ  ǥϴ ׸ Ʈ
void CPage2::UpdateBackupDataGrid()
{
	int iSel = m_GridBackupList.GetRow() - 1;
	int FrameCount = this->m_BackupMotion[iSel].GetFrameCount();

	m_GridBackupData.SetRows( FrameCount + 1 );

	for( int i = 1; i < FrameCount; i++ )
	{
		int j = i - 1;
		m_GridBackupData.SetInt( i, 0, m_BackupMotion[iSel][j].m_iID );
		m_GridBackupData.SetString( i, 1, MotorNameManager[ m_BackupMotion[iSel][j].m_iID ].c_str() );
		m_GridBackupData.SetInt( i, 2, m_BackupMotion[iSel][j].m_iPos );
		m_GridBackupData.SetInt( i, 3, m_BackupMotion[iSel][j].m_iSpeed );
	}

}

//  ǵ ȣ ǥϴ ׸ Ʈ
void CPage2::UpdateBackupListGrid()
{
	m_GridBackupList.SetRows( m_BackupMotion.size() + 1 );

	for( int i = 0; i < m_BackupMotion.size(); i++ )
	{
		m_GridBackupList.SetInt( i + 1, 0, i );
	}
}

// ġ ٲ ͵  ǥϴ ׸ Ʈ
void CPage2::UpdateChangedMotorsGrid()
{
	int FrameCount = m_WorkingMotion.GetFrameCount();

	m_GridChanged.SetRows( FrameCount + 1 );

	for( int i = 0; i < FrameCount; i++ )
	{
		int Row = i + 1;

		m_GridChanged.SetInt( Row, 0, m_WorkingMotion[i].m_iID );
		m_GridChanged.SetString( Row, 1, MotorNameManager[ m_WorkingMotion[i].m_iID ].c_str() );
		m_GridChanged.SetInt( Row, 2, m_WorkingMotion[i].m_iPos );
		m_GridChanged.SetInt( Row, 3, m_WorkingMotion[i].m_iSpeed );
	}
}

//   ǵ  ǥϴ ׸ Ʈ
void CPage2::UpdateMotionListGrid()
{
	int i = 0;

	MotionMap Map = MotionManager.GetMap();
	MotionMap::iterator iter;


	int SingleCount = 0;

	for( iter = Map.begin(); iter != Map.end(); iter++ )
	{
		if( iter->second->GetType() == "CSingleMotion" )
			SingleCount++;
	}

	m_GridMotionList.SetRows( SingleCount + 1 );

	for( iter = Map.begin(); iter != Map.end(); iter++ )
	{
		int row = i + 1;

		CMotion* temp = iter->second;

		if( temp->GetType() != "CSingleMotion" )
			continue;

		m_GridMotionList.SetInt( row, 0, i );
		m_GridMotionList.SetString( row, 1, temp->GetName().c_str() );
		m_GridMotionList.SetString( row, 2, temp->GetAuthor().c_str() );

		i++;
	}
}

BEGIN_EVENTSINK_MAP(CPage2, CPropertyPage)
	ON_EVENT(CPage2, IDC_BACKUPLIST, 69, SelChangeBackuplist, VTS_NONE)
	ON_EVENT(CPage2, IDC_CHANGEDMOTORS, 69, SelChangeChangedmotors, VTS_NONE)
END_EVENTSINK_MAP()

void CPage2::SelChangeBackuplist()
{
	this->UpdateBackupDataGrid();
}

void CPage2::OnBnClickedRuntempmotion2()
{
	CString szTemp;

	InitProgressBar( m_GridChanged.GetRows() - 1 + 40 );

	for( int i = 0; i < m_GridChanged.GetRows() - 1; i++ )
	{
		m_WorkingMotion[i].m_iID = m_GridChanged.GetInt( i + 1, 0 );
		m_WorkingMotion[i].m_iPos = m_GridChanged.GetInt( i + 1, 2 );
		m_WorkingMotion[i].m_iSpeed = m_GridChanged.GetInt( i + 1, 3 );
	}

//	PacketManager.ClearQue();
//	g_SerialPort.ClearBuffer();
/*
	for( int i = 1; i < this->m_GridChanged.GetRows(); i++ )
	{
		int ID   = m_GridChanged.GetInt( i, 0 );
		int Pos  = m_GridChanged.GetInt( i, 2 );
		int Speed= m_GridChanged.GetInt( i, 3 );

		//CAIMotor *pMotor = MotorManager::Instance().GetMotor( ID );
		CAIMotor *pMotor = AIMotorManager[ID];

		PacketManager.Send( CSetPosition( ID, Pos, Speed ), false );

		g_SerialPort.Delay( 1 );
		UpdateProgressBar();
	}

	for( int i = 0; i < 40; i++ )
	{
        g_SerialPort.Delay( 10 );
		UpdateProgressBar();
	}
*/

	m_WorkingMotion.Run();

//	g_SerialPort.ClearBuffer();
//	PacketManager.ClearQue();
}

void CPage2::SelChangeChangedmotors()
{
	int iRow = m_GridChanged.GetRow() - 1;
	
	for( int i = 0; i < m_GridChanged.GetRows() - 1; i++ )
	{
		m_WorkingMotion[i].m_iID = m_GridChanged.GetInt( i + 1, 0 );
		m_WorkingMotion[i].m_iPos = m_GridChanged.GetInt( i + 1, 2 );
		m_WorkingMotion[i].m_iSpeed = m_GridChanged.GetInt( i + 1, 3 );
	}
}

// ̹   
void CPage2::OnBnClickedEditsinglemotion()
{
//	MessageBox( "!! ȵ!" );
//	return;

	// TODO : ̹   

	if( MessageBox( "ϵ  մϴ.\n"
		"۾̴ ʹ  ϴ. Ͻðڽϱ?", "", MB_ICONQUESTION | MB_YESNO ) != IDYES )	
		return;

	MotionMap Map = MotionManager.GetMap();
	int iSel = m_GridMotionList.GetRow();

	//CString name = m_GridMotionList.GetString( iSel, 1 );
	CString name = m_GridMotionList.GetTextMatrix( iSel, 1 );
    
	CSingleMotion* temp = (CSingleMotion*)(Map[name.GetBuffer()]);
	m_WorkingMotion = *temp;

	m_strMotionName = temp->GetName().c_str();;
	m_strAuthor = temp->GetAuthor().c_str();

	UpdateData(FALSE);


	this->UpdateChangedMotorsGrid();
}

void CPage2::OnBnClickedRunsinglemotion()
{
	// TODO: ⿡ Ʈ ˸ ó ڵ带 ߰մϴ.
	int iRow = this->m_GridMotionList.GetRow();

	CString sMotionName = m_GridMotionList.GetTextMatrix( iRow, 1 );

	MotionMap Map = MotionManager.GetMap();

	Map[ sMotionName.GetBuffer() ]->Run();
}

void CPage2::OnBnClickedSetspeed()
{
//	m_GridChanged.
	UpdateData();

	int Sel = m_GridChanged.GetRow();
//	m_GridChanged.SetInt( Sel, 2, m_iSpeed );

	for( int i = 0; i < m_WorkingMotion.GetFrameCount(); i++ )
        m_WorkingMotion[ i ].m_iSpeed = m_iSpeed;

	this->UpdateChangedMotorsGrid();
}

BOOL CPage2::OnSetActive()
{
	// TODO: ⿡ Ưȭ ڵ带 ߰ /Ǵ ⺻ Ŭ ȣմϴ.

	this->UpdateBackupListGrid();
	this->UpdateChangedMotorsGrid();
	this->UpdateMotionListGrid();

	return CPropertyPage::OnSetActive();
}

void CPage2::OnBnClickedCapall()
{
	MotorMap Map = AIMotorManager.GetMotorMap();

	for( MotorMap::iterator iter = Map.begin(); iter != Map.end(); iter++ )
	{
		iter->second->m_bCapture = true;
	}
}

void CPage2::OnBnClickedDontcapall()
{
	MotorMap Map = AIMotorManager.GetMotorMap();

	for( MotorMap::iterator iter = Map.begin(); iter != Map.end(); iter++ )
	{
		iter->second->m_bCapture = false;
	}
}

void CPage2::OnBnClickedStartcap2()
{
	m_bCheckChangedMotor = false;
	MotorMap Map = AIMotorManager.GetMotorMap();

	InitProgressBar( Map.size() );	

//	g_SerialPort.ClearBuffer();
//	PacketManager.ClearQue();

	AIMotorManager.SendGetPositionAll();
	g_SerialPort.Delay( 30 );

	m_LastPosition.clear();

	g_SerialPort.ClearBuffer();
	PacketManager.ClearQue();

	///  ŭ   ġ о Ŷ .
	for( MotorMap::iterator iter = Map.begin(); iter != Map.end(); iter++ )
	{
		int ID = iter->first;
		CAIMotor *pMotor = iter->second;

		UpdateProgressBar(); 

//		if( pMotor->m_bCapture )
		{
			PacketManager.Send( CGetPosition( ID ), false );

			//  Ŷ    ֵ ణ ̸ ش.
			g_SerialPort.Delay( 40 );
		}
	}

	g_SerialPort.Delay( 40 );

	g_SerialPort.ClearBuffer();
	PacketManager.ClearQue();

	/// о ġ Ѵ.
	for( MotorMap::iterator iter = Map.begin(); iter != Map.end(); iter++ )
	{
		int ID = iter->first;
		CAIMotor* pMotor = iter->second;

		LASTPOSITION Temp;

		Temp.ID = ID;
		Temp.Pos = pMotor->GetPosition();

		m_LastPosition.push_back( Temp );

		UpdateProgressBar(); 
	}

}
