// Page3.cpp :  Դϴ.
//

#include "stdafx.h"
#include "Baram2.h"
#include "Page3.h"
#include ".\page3.h"


// CPage3 ȭ Դϴ.

IMPLEMENT_DYNAMIC(CPage3, CPropertyPage)
CPage3::CPage3()
	: CPropertyPage(CPage3::IDD)
	, m_strMotionName(_T(""))
	, m_strAuthor(_T(""))
	, m_iDelay(0)
{
}

CPage3::~CPage3()
{
}

void CPage3::DoDataExchange(CDataExchange* pDX)
{
	CPropertyPage::DoDataExchange(pDX);

	DDX_Text(pDX, IDC_MOTIONAUTHOR2, m_strAuthor);
	DDX_Text(pDX, IDC_MOTIONNAME2, m_strMotionName);
	DDX_Text(pDX, IDC_DELAY, m_iDelay );

		
	DDX_Control(pDX, IDC_NEWCONNECTEDMOTION, m_btnNewMotion);
	DDX_Control(pDX, IDC_DISCONNECTMOTION, m_btnDisconnectMotion);
	DDX_Control(pDX, IDC_RUNMOTION, m_btnRunMotion);
	DDX_Control(pDX, IDC_DELAY, m_Delay);
	DDX_Control(pDX, IDC_CONNECTMOTION, m_btnConnectMotion);
	DDX_Control(pDX, IDC_RUNCONNECTEDMOTION, m_btnRunConnectedMotion);
	DDX_Control(pDX, IDC_REMOVECONNECTEDMOTION, m_btnRemoveConnectedMotion);
	DDX_Control(pDX, IDC_EDITCONNECTEDMOTION, m_btnEditConnectedMotion);

	DDX_Control(pDX, IDC_CONNECTEDMOTIONS, m_GridConnected );
	DDX_Control(pDX, IDC_ALLMOTION, m_GridAll );
	DDX_Control(pDX, IDC_ALLCONNECTEDMOTION, m_GridConnectedAll);

	DDX_Control(pDX, IDC_SAVECONNECTEDMOTION, m_btnSaveConnectedMotion);
}


BEGIN_MESSAGE_MAP(CPage3, CPropertyPage)
	ON_BN_CLICKED(IDC_DISCONNECTMOTION, OnBnClickedDisconnectmotion)
	ON_BN_CLICKED(IDC_SAVECONNECTEDMOTION, OnBnClickedSaveconnectedmotion)
	ON_BN_CLICKED(IDC_RUNMOTION, OnBnClickedRunmotion)
	ON_BN_CLICKED(IDC_CONNECTMOTION, OnBnClickedConnectmotion)
	ON_WM_ACTIVATE()
	ON_WM_SETFOCUS()
	ON_BN_CLICKED(IDC_NEWCONNECTEDMOTION, OnBnClickedNewconnectedmotion)
	ON_BN_CLICKED(IDC_RUNCONNECTEDMOTION, OnBnClickedRunconnectedmotion)
	ON_BN_CLICKED(IDC_EDITCONNECTEDMOTION, OnBnClickedEditconnectedmotion)
END_MESSAGE_MAP()


// CPage3 ޽ óԴϴ.

void CPage3::OnBnClickedDisconnectmotion()
{
	int Row = m_GridConnected.GetRow();

	m_WorkingMotion.RemoveMotion( m_GridConnected.GetString( Row, 1 ).GetBuffer() );

	this->UpdateConnectedGrid();
}


void CPage3::InitGridCtrl()
{
	// ׸ ÷  
	m_GridConnected.SetColWidth( 0, ( 41 * 15 ) ); 
	m_GridConnected.SetColWidth( 1, ( 170 * 15 ) );
	m_GridConnected.SetColWidth( 2, ( 50 * 15 ) );

	m_GridAll.SetColWidth( 0, ( 41 * 15 ) ); 
	m_GridAll.SetColWidth( 1, ( 130 * 15 ) );
	m_GridAll.SetColWidth( 2, ( 60 * 15 ) );

	m_GridConnectedAll.SetColWidth( 0, ( 41 * 15 ) ); 
	m_GridConnectedAll.SetColWidth( 1, ( 340 * 15 ) );
	m_GridConnectedAll.SetColWidth( 2, ( 83 * 15 ) );
	m_GridConnectedAll.SetColWidth( 3, ( 55 * 15 ) );



	// 
	m_GridConnected.SetString( 0, 0, "ȣ" );
	m_GridConnected.SetString( 0, 1, " ̸" );
	m_GridConnected.SetString( 0, 2, "" );

	m_GridAll.SetString( 0, 0, "ȣ" );
	m_GridAll.SetString( 0, 1, " ̸" );
	m_GridAll.SetString( 0, 2, "ۼ" );

	m_GridConnectedAll.SetString( 0, 0, "ȣ" );
	m_GridConnectedAll.SetString( 0, 1, " ̸" );
	m_GridConnectedAll.SetString( 0, 2, "" );
	m_GridConnectedAll.SetString( 0, 3, " " );

	UpdateAllGrid();
	UpdateConnectedGrid();

//	m_GridBackupList.SetString( 0, 0, "No." );
}

BOOL CPage3::OnInitDialog()
{
	CPropertyPage::OnInitDialog();

	InitGridCtrl();

	return TRUE;  // return TRUE unless you set the focus to a control
	// : OCX Ӽ  FALSE ȯؾ մϴ.
}

void CPage3::UpdateAllGrid()
{
	int i = 0;

	MotionMap Map = MotionManager.GetMap();
	MotionMap::iterator iter;

	m_GridAll.SetRows( Map.size() + 1 );

	for( iter = Map.begin(); iter != Map.end(); iter++ )
	{
		int row = i + 1;

		CMotion* temp = iter->second;

		m_GridAll.SetInt( row, 0, i );
		m_GridAll.SetString( row, 1, temp->GetName().c_str() );
		m_GridAll.SetString( row, 2, temp->GetAuthor().c_str() );

		i++;
	}
}

void CPage3::UpdateConnectedGrid()
{
	m_GridConnected.SetRows( m_WorkingMotion.GetMotionCount() + 1 );
	for( int i = 0; i < m_WorkingMotion.GetMotionCount(); i++ )
	{
		//string sMotionName = m_WorkingMotion[i].pMotion->GetName();
		string sMotionName = m_WorkingMotion[i].Name;
		int	   Delay = m_WorkingMotion[i].Delay;

		m_GridConnected.SetInt( i + 1, 0, i );
		m_GridConnected.SetString( i + 1, 1, sMotionName.c_str() );
		m_GridConnected.SetInt( i + 1, 2, Delay );
	}
}

void CPage3::OnBnClickedSaveconnectedmotion()
{
	// TODO: ⿡ Ʈ ˸ ó ڵ带 ߰մϴ.

	UpdateData();

	int count = m_WorkingMotion.GetMotionCount();

	if( count < 2 )
	{
		MessageBox( "ϸ 峭? Ȱ ڳ!!! ּ ΰ ̻ plz~~" );
		return;
	}

	m_WorkingMotion.SetName( m_strMotionName.GetBuffer() );
	m_WorkingMotion.SetAuthor( m_strAuthor.GetBuffer() );

	CMotion* temp = new CLinkedMotion( m_WorkingMotion );

	bool bResult = MotionManager.AddMotion( m_strMotionName.GetBuffer(), temp );

	if( bResult == false )
	{
		if( MessageBox( " ̸   ̹ ֽϴ. \n"
			"ðڽϱ? ( ʹ  ϴ.)", "", MB_ICONQUESTION | MB_YESNO ) == IDYES )
		{
			MotionManager.AddMotion( m_strMotionName.GetBuffer(), temp, true );
		}
		else
			delete temp;
	}

	this->updateConnectedAllGrid();
	this->UpdateAllGrid();

	
}

void CPage3::OnBnClickedRunmotion()
{
	// TODO: ⿡ Ʈ ˸ ó ڵ带 ߰մϴ.

	m_WorkingMotion.Run();
}

void CPage3::OnBnClickedConnectmotion()
{
	// TODO: ⿡ Ʈ ˸ ó ڵ带 ߰մϴ.

	this->UpdateData();

	int iRow = m_GridAll.GetRow();
	MotionMap Map = MotionManager.GetMap();
	CString sMotionName = m_GridAll.GetTextMatrix( iRow, 1 );	

	m_WorkingMotion.AddMotion( Map[ sMotionName.GetBuffer() ], m_iDelay );

	UpdateConnectedGrid();
}


void CPage3::OnActivate(UINT nState, CWnd* pWndOther, BOOL bMinimized)
{
	CPropertyPage::OnActivate(nState, pWndOther, bMinimized);

	UpdateAllGrid();
	UpdateConnectedGrid();
	// TODO: ⿡ ޽ ó ڵ带 ߰մϴ.
}

void CPage3::OnSetFocus(CWnd* pOldWnd)
{
	CPropertyPage::OnSetFocus(pOldWnd);

	// TODO: ⿡ ޽ ó ڵ带 ߰մϴ.
}

BOOL CPage3::OnSetActive()
{
	// TODO: ⿡ Ưȭ ڵ带 ߰ /Ǵ ⺻ Ŭ ȣմϴ.

	m_WorkingMotion.RefreshPointer();

	UpdateAllGrid();
	UpdateConnectedGrid();
	updateConnectedAllGrid();

	return CPropertyPage::OnSetActive();
}

void CPage3::updateConnectedAllGrid()
{
	MotionMap Map = MotionManager.GetMap();
	MotionMap::iterator iter;

	int linkedCount = 0;

	for( iter = Map.begin(); iter != Map.end(); iter++ )
	{
		if( iter->second->GetType() == "CLinkedMotion" )
			linkedCount++;
	}

	m_GridConnectedAll.SetRows( linkedCount + 1 );

	int i = 0;
	for( iter = Map.begin(); iter != Map.end(); iter++ )
	{
		int row = i + 1;

		CMotion* temp = iter->second;

		if( temp->GetType() != "CLinkedMotion" )
			continue;

		CLinkedMotion* Motion = (CLinkedMotion*)temp;

		m_GridConnectedAll.SetInt( row, 0, i );
		m_GridConnectedAll.SetString( row, 1, Motion->GetName().c_str() );
		m_GridConnectedAll.SetString( row, 2, Motion->GetAuthor().c_str() );
		m_GridConnectedAll.SetInt( row, 3, Motion->GetMotionCount() );

		i++;
	}
}
void CPage3::OnBnClickedNewconnectedmotion()
{
	// TODO: ⿡ Ʈ ˸ ó ڵ带 ߰մϴ.

	m_WorkingMotion.Clear();

	UpdateConnectedGrid();
}

void CPage3::OnBnClickedRunconnectedmotion()
{
	int iRow = this->m_GridConnectedAll.GetRow();

	CString sMotionName = m_GridConnectedAll.GetTextMatrix( iRow, 1 );

	MotionMap Map = MotionManager.GetMap();

	Map[ sMotionName.GetBuffer() ]->Run();
}

void CPage3::OnBnClickedEditconnectedmotion()
{
	int iRow = this->m_GridConnectedAll.GetRow();
	CString sMotionName = m_GridConnectedAll.GetTextMatrix( iRow, 1 );

	MotionMap Map = MotionManager.GetMap();
	m_WorkingMotion = *( (CLinkedMotion*)Map[ sMotionName.GetBuffer() ] );

	m_strAuthor = m_WorkingMotion.GetAuthor().c_str();
	m_strMotionName = m_WorkingMotion.GetName().c_str();

	UpdateData( FALSE );

	this->UpdateConnectedGrid();
}
BEGIN_EVENTSINK_MAP(CPage3, CPropertyPage)
	ON_EVENT(CPage3, IDC_CONNECTEDMOTIONS, 72, LeaveCellConnectedmotions, VTS_NONE)
	ON_EVENT(CPage3, IDC_CONNECTEDMOTIONS, 69, SelChangeConnectedmotions, VTS_NONE)
END_EVENTSINK_MAP()

void CPage3::LeaveCellConnectedmotions()
{
	// TODO: ⿡ ޽ ó ڵ带 ߰մϴ.

	int Row = m_GridConnected.GetRow();
	int Delay = m_GridConnected.GetInt( Row, 2 );

	m_WorkingMotion[Row-1].Delay = Delay;
}

void CPage3::SelChangeConnectedmotions()
{
	int Row = m_GridConnected.GetRow();
	int Delay = m_GridConnected.GetInt( Row, 2 );

	m_WorkingMotion[Row-1].Delay = Delay;
}
