#include "StdAfx.h"

#include "AIMotorManager.h"
#include "AIMotor.h"

#include "PacketGenerator.h"

#include "PacketManager.h"



/**
	@remarks
		޸𸮿 Ҵ Ͱü ͸  Ͽ ߰Ѵ.	

	@param CAIMotor *pMotor
	@return bool 
	@date 2004 6 28   10:36:19
*/
bool CAIMotorManager::AddMotor( CAIMotor *pMotor )
{
	if( !pMotor )
		return false;

	m_Map.insert( MotorMap::value_type( pMotor->GetID(), pMotor ) );

	if( !m_Map[pMotor->GetID()] )
		return false;

	return true;
}



/**
	@remarks
		  ߿ شǴ id  ͸ ޸𸮿 ϰ,
		 Ͽ .

	@param int id
	@return void 
	@date 2004 6 28   10:36:13
*/
void CAIMotorManager::DeleteMotor( int id )
{ 
	delete m_Map[id];
	m_Map.erase( id );
}



/**
	@remarks
		  Ͱü ޸𸮸 ϰ  Ͽ .
	
	@return void 
	@date 2004 6 28   10:36:08
*/
void CAIMotorManager::DeleteAll()
{	
	for( MotorMap::iterator iter = m_Map.begin(); iter != m_Map.end(); iter++ )
	{
//		CAIMotor *pMotor = iter->second;
		delete iter->second;
	}

	m_Map.erase( m_Map.begin(), m_Map.end() );

}



/**
	@remarks
		 ͸ ޸𸮿 , ͸ Ѵ.
	
	@param	int ID		 ID
	
	@return CAIMotor*	  
	
	@author Star.
*/
CAIMotor* CAIMotorManager::NewMotor( int ID )
{
	AddMotor(new CAIMotor( ID ));

	CAIMotor* Motor = GetMotor( ID );

	return Motor;
}




/**
	@remarks
		ϵ  ͵  ġ о Ŷ .	
	
	@author Star.
	@date   2004 7 29   5:05:59
*/
void CAIMotorManager::SendGetPositionAll()
{
	for( MotorMap::iterator iter = m_Map.begin(); iter != m_Map.end(); iter++ )
	{
		PacketManager.Send( CGetPosition( iter->first ), false );
	}
}