#if !defined(AFX_EDITFLEXGRID_H__E893F58D_FA15_4FED_B756_4C721BA2CB04__INCLUDED_)
#define AFX_EDITFLEXGRID_H__E893F58D_FA15_4FED_B756_4C721BA2CB04__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000
// EditFlexGrid.h : header file
//

/////////////////////////////////////////////////////////////////////////////
// CEditFlexGrid window
#include "msflexgrid.h"
#include "CellEdit.h"

class CEditFlexGrid : public CExtWRB<  CExtWFF< CExtWS < CMSFlexGrid > > > 
{
// Construction
public:
	CEditFlexGrid();

// Attributes
private:
	CCellEdit m_edit;
	CFont* m_font;
	int m_pixelsperinchx;
	int m_pixelsperinchy;
// Operations
private:
	void ShowEditBox();
	void HideEditBox();
	
// Overrides
	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CEditFlexGrid)
	protected:
	virtual void PreSubclassWindow();
	//}}AFX_VIRTUAL

// Implementation
public:
	virtual ~CEditFlexGrid();

	void SetString( int row, int col, const CString& str );
	void SetInt( int row, int col, const int val );

	CString  GetString( int row, int col ) ;
	int		 GetInt( int row, int col ) ;
	

	// Generated message map functions
protected:
	//{{AFX_MSG(CEditFlexGrid)
	afx_msg UINT OnGetDlgCode();
	afx_msg void OnDblClick();
	afx_msg void OnScroll();
	afx_msg void OnKeyDownFlex(short FAR* KeyCode, short Shift);
	afx_msg void OnLeaveCell();
	DECLARE_EVENTSINK_MAP()
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
public:
	afx_msg BOOL OnMouseWheel(UINT nFlags, short zDelta, CPoint pt);
};

/////////////////////////////////////////////////////////////////////////////

//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_EDITFLEXGRID_H__E893F58D_FA15_4FED_B756_4C721BA2CB04__INCLUDED_)
