#include "StdAfx.h"
#include "MotorNameManager.h"


/**
	@remarks
		. private Ӽ̱  ̱ ̿ؼ  . 

	@author Star.
	@date   004 7 9 ݿ  12:51:33
*/
CMotorNameManager::CMotorNameManager(void)
{
	for( int i = 0; i < 31; i++ )
	{
		m_NameArray.push_back( "Empty" );		
	}
	
}


/**
	@remarks
	
	@param		istream &stream
	
	@return		bool 
	
	@author Star.
	@date   2004 7 9 ݿ  12:55:44
*/
bool CMotorNameManager::Reset( istream &stream )
{
	m_NameArray.clear();

	for( int i = 0; i < 31; i++ )
	{
		stream >> m_NameArray[i];
	}

	if( m_NameArray.size() != 31 )
		return false;

	return true;
}


/**
	@remarks
	
	@param	ostream& lhs
	@param	CMotorNameManager& rhs
	
	@return ostream& operator 
	
	@author Star.
	@date   2004 7 9 ݿ  1:42:12
*/
ostream& operator << ( ostream& lhs, CMotorNameManager& rhs )
{
	rhs.SaveData();
	lhs << rhs.m_Stream;

	return lhs;
}


/**
	@remarks
	
	@param	istream& lhs
	@param	CMotorNameManager& rhs
	
	@return istream& operator 
	
	@author Star.
	@date   2004 7 9 ݿ  1:49:10
*/
istream& operator >> ( istream& lhs, CMotorNameManager& rhs )
{
	for( int i = 0; i < 31; i++ )
	{
		lhs >> rhs.m_NameArray[i];
	}

	return lhs;
}



/**	
	@remarks
		 Ʈ  ̸ ͸ Ѵ.
	
	
	@return bool 
	
	@author Star.
	@date   2004 7 9 ݿ  2:09:34
*/
bool CMotorNameManager::SaveData()
{
	m_Stream.flush();

	for( int i = 0; i < 31; i++ )
	{
		m_Stream << m_NameArray[i];
	}	

	return true;
	
}



/**
	@remarks
		 ID ̿  ̸ ȯ.
	
	@param	int ID
	
	@return string&
	
	@author Star.
	@date   2004 7 9 ݿ  3:06:38
*/
string& CMotorNameManager::operator [] ( int ID )
{
	return m_NameArray[ID];
}



/**
	@remarks
		 ̸ Է¹޾  ̸   ID ȯ
	
	@param	string& Name	 ̸
	
	@return int				ã  ID, ã ϸ -1 ȯ.
	
	@author Star.
	@date   2004 7 9 ݿ  3:07:47
*/
int CMotorNameManager::operator [] ( string& Name )
{
	for( int i = 0; i < 31; i++ )
	{
		if( m_NameArray[i] == Name )
			return i;
	}

	return -1;
}