#pragma once

#include "Singleton.h"

#include <vector>
#include <string>
#include <sstream>


using namespace std;
using namespace Loki;


typedef vector< string >	NameArray;		///< 31 ̸  迭

/**  ID ̸(Ī) 踦 ֱ̾  Ŭ.
*
*	 ID  κ  ġ  ˱ .
*	  ͸ ̸  ( ex. 1,  ߹ٴ,  ߹ٴ )
*	 ID   ,   ظ  Ŭ̴.
*
*	̱  ߴ.
*
*	@author Star.
*	@date 2004 7 9 ݿ  12:25:25
*/	
class CMotorNameManager
{
	NameArray	m_NameArray;

	ostringstream	m_Stream;
	
private:
	CMotorNameManager(void);
	~CMotorNameManager(void)
	{
	}

public:
	friend class  SingletonHolder< CMotorNameManager >;
	friend struct CreateUsingNew< CMotorNameManager >;

	friend ostream& operator << ( ostream& lhs, CMotorNameManager& rhs );
	friend istream& operator >> ( istream& lhs, CMotorNameManager& rhs );

	string&	operator [] ( int ID );
	int		operator [] ( string& Name );

	bool	Reset( istream& stream );

	bool	SaveData();
	
};

//! ID ̸ << ڸ  ٸ  Ʈ ϱ   ε.
ostream& operator << ( ostream& lhs, CMotorNameManager& rhs );

//! Է Ʈ ID ̸踦 о   ε.
istream& operator >> ( istream& lhs, CMotorNameManager& rhs );


typedef SingletonHolder< CMotorNameManager >	SingleMotorNameManager;
#define	 MotorNameManager	SingleMotorNameManager::Instance()