#pragma once

#include <vector>

#include "EditFlexGrid.h"
#include "afxwin.h"
#include "afxcmn.h"

#include "MotionManager.h"

using namespace std;


struct LASTPOSITION
{
	int ID;
	int Pos;

	bool operator == ( LASTPOSITION& rhs )
	{
		if( ID == rhs.ID )
			if( Pos == rhs.Pos )
				return true;

		return false;
	}
};

// CPage2 ȭ Դϴ.

//class CPage2 : public CPropertyPage
class CPage2 : public CPropertyPage
{
	DECLARE_DYNAMIC(CPage2)


	CEditFlexGrid m_GridChanged;					///< ĸ   ġ ٲ ͵
	CEditFlexGrid m_GridBackupList;					///<    ǥ
	CEditFlexGrid m_GridBackupData;					///<  ͸ ǥ
	CEditFlexGrid m_GridMotionList;					///< ϵ ü   

	vector< LASTPOSITION >	  m_LastPosition;					///< ĸ    ġ
	vector<CSingleMotion> m_BackupMotion;					///<  ǵ

	CSingleMotion		m_WorkingMotion;				///< ۾ 

	bool	m_bCheckChangedMotor;

public:
	CPage2();
	virtual ~CPage2();

	void InitGridCtrl();


// ȭ  Դϴ.
	enum { IDD = IDD_PAGE2 };

protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV Դϴ.

	DECLARE_MESSAGE_MAP()
public:
	afx_msg void OnBnClickedStartcap();

protected:
	virtual LRESULT WindowProc(UINT message, WPARAM wParam, LPARAM lParam);
public:
	virtual BOOL OnInitDialog();

	CExtButton m_btnStartCapture;
	CExtButton m_btnStartCapture2;
	CExtButton m_btnStopCapture;
	CExtButton m_btnRunTempMotion;
	CExtButton m_btnSetBackPosition;
	CExtButton m_btnBackup;
	CExtButton m_btnRestore;
	CExtButton m_btnDeleteBackup;
	CExtButton m_btnRunTempMotion2;
	CExtButton m_btnRunBackupMotion;
	CExtButton m_btnSaveMotion;
	CExtButton m_btnRunSingleMotion;
	CExtButton m_btnRemoveSingleMotion;
	CExtButton m_btnEditSingleMotion;
	CExtButton m_btnCapAll;
	CExtButton m_btnDontCapAll;

	afx_msg void OnBnClickedStopcap();
	afx_msg void OnBnClickedRuntempmotion();
	afx_msg void OnBnClickedSetposback();
	afx_msg void OnBnClickedBackup();
	afx_msg void OnBnClickedBackupdelete();
	afx_msg void OnBnClickedRestore();
	afx_msg void OnBnClickedSavemotion();

	void	InitProgressBar( int Max );			///< α׷  ʱȭ.
	void	UpdateProgressBar();				///< α׷   1 Ŵ.

	void	UpdateChangedMotorsGrid();
	void	UpdateBackupListGrid();
	void	UpdateBackupDataGrid();
	void	UpdateMotionListGrid();

	CExtWRB< CExtWFF< CProgressCtrl > > m_ProgressBar;
	DECLARE_EVENTSINK_MAP()
	void SelChangeBackuplist();
	afx_msg void OnBnClickedRuntempmotion2();
	void SelChangeChangedmotors();
	CString m_strMotionName;
	CString m_strAuthor;
	afx_msg void OnBnClickedEditsinglemotion();
	afx_msg void OnBnClickedRunsinglemotion();
	int m_iSpeed;
	afx_msg void OnBnClickedSetspeed();
	virtual BOOL OnSetActive();
	afx_msg void OnBnClickedCapall();
	afx_msg void OnBnClickedDontcapall();
	afx_msg void OnBnClickedStartcap2();
};
