#include "stdafx.h"

#include "sbitmap.h"
#include <assert.h>

/******************************************************************************
 D3D ؽĸ ε  ũ⸦ ٲٴ  
  ߾µ..

ǥ شٰ ص Ȯ ̹ ٽ  ϴ 
̹ ջ  ..

μ ذ   ..

 Ʈʵ 2 ¼ ؼ   ۿ..

2002 6 17   11:47:07		`Star.-

/******************************************************************************
 ̹  Ŭ   ϰ .
DDraw ǽ ?  Ʈʿ   ׸   ǰ
ũ ȭ鿡 ׷ִ ͸ .

Ʈ ؽķ ҷ̰ ID3DXSprite   ִ .

 640 * 480¥ ׸ ҷ´ٰ ϸ,  εǴ ؽ ũ
 ջŰ ʰ   2 ¼ ڵ ȯ.

 640 * 480 1024 * 512 ҷδٴ .

 ϴ ۾ ڿ  ٴ 384 * 32 ̹ ׳ ̸ ٵ
 ׸ Ȯؼ εϴ .

 DDrawó  ؼ  ǥ ȯ ۾ ʿ.

Original X :  ׸ ǥ,     Original Size :  ׸ ũ
Texture X  : ε ؽĿ ǥ, Texture Size  : ε ؽ ũ

Texture X = ( Original X * Texture Size ) / Original Size


2002 6 3   11:44:20     `Star.-
*******************************************************************************/

CSBitmap::CSBitmap(void)
{
	m_pBitmap = NULL;
	m_pTexture= NULL;

	m_pd3dDevice = NULL;

	m_ColorKey = 0xFF000000;

}

CSBitmap::~CSBitmap(void)
{
	SAFE_RELEASE( m_pTexture );
	SAFE_RELEASE( m_pBitmap );
}

void CSBitmap::SetDevice( LPDIRECT3DDEVICE9 pd3dDevice )
{
	m_pd3dDevice = pd3dDevice;
}


// Լ ̸ : CSBitmap::Load
// Լ  : ׸ ҽ ҷδ.
// ȯ  : HRESULT 
//       : LPSTR FileName
//    ۼ : `Star.-  ( 2002-06-02  2:47:51 )
HRESULT CSBitmap::Load( LPDIRECT3DDEVICE9 pd3dDevice, LPSTR FileName, D3DCOLOR ColorKey )
{
	assert( !m_pBitmap && !m_pTexture );

	m_pd3dDevice = pd3dDevice;

	if( !m_pd3dDevice )
		return E_FAIL;

	D3DXIMAGE_INFO SrcInfo;
	
	D3DXCreateTextureFromFileEx( 
		m_pd3dDevice,		// D3D8 Device
		FileName,			//  ̸
		0,					//  ũ ( 0 = ̹ ũ )
		0,					//  ũ ( 0 = ̹ ũ )
		1,					// Ӹ 
		0,					// ɼ.. (   -_- )
		D3DFMT_A8R8G8B8,    // ؽ 
		D3DPOOL_MANAGED,    // ޸  (?)
		D3DX_FILTER_NONE,	// 
		D3DX_FILTER_NONE,	// 2 ..
		ColorKey,			// ÷Ű
		&SrcInfo,			// ε Ʈ 
		NULL,				// ȷƮ
		&m_pTexture );

	m_BitmapInfo = SrcInfo;

	if( FAILED( GetInformation() ) )
		return E_FAIL;


	// ÷Ű ڵ ãƴ޶~  û   -_-;
	if( ColorKey == CSBITMAP_AUTOFIND )
	{

		BYTE r, g, b;
		DWORD Color;
		
		DWORD* p = GetBitsPointer();

		r = GET_R(*p);
		g = GET_G(*p);
		b = GET_B(*p);

		Color = D3DCOLOR_ARGB( 0, r, g, b );

		for( int i = 0; i < GetHeight(); i++ )
		{
			for( int j = 0; j < GetWidth(); j++ )
			{
				DWORD _Color = *p;

				BYTE _r, _g, _b;

				_r = GET_R( _Color );
				_g = GET_G( _Color );
				_b = GET_B( _Color );

				_Color = D3DCOLOR_ARGB( 0, _r, _g, _b );

				if( Color == _Color )
				{
					*p = _Color;
				}

				p++;
			}
		}

	}

	// Sprite 
	D3DXCreateSprite( m_pd3dDevice, &m_pBitmap );

	m_ColorKey = ColorKey;

	if( m_pBitmap )
		return S_OK;
	else
		return E_FAIL;

}


HRESULT CSBitmap::Create( LPDIRECT3DDEVICE9 pDevice, UINT Width, UINT Height, UINT Levels, 
						   DWORD Usage, D3DFORMAT Format, D3DPOOL Pool )
{
	m_pd3dDevice = pDevice;

	pDevice->CreateTexture( Width, Height, Levels, Usage, Format, Pool, &m_pTexture, NULL );
	
	// Sprite 
	HRESULT hr = D3DXCreateSprite( m_pd3dDevice, &m_pBitmap );

	GetInformation();

	return hr;
}

// Լ ̸ : CSBitmap::Draw
// Լ  : о Ʈ ȭ鿡 ׷.	( (-_-) Լ )
// ȯ  : HRESULT 
//       : float x			//   ׷ xǥ
//       : float y			// 
//       : float Angle		// ȸ      (  )
//       : D3DXVECTOR2 _RCenter		// ȸ ߽
//       : D3DXVECTOR2 _Scaling		// Ȯ
//       : RECT* pSrcRect			//  ׷ 
//       : RECT* pDestRect			// ȭ ׷ 
//    ۼ : `Star.-  ( 2002-06-02  2:53:16 )
HRESULT CSBitmap::Draw( float x, float y, float Angle, D3DXVECTOR2 _RCenter, D3DXVECTOR2 _Scaling,
					   RECT* pSrcRect, RECT* pDestRect )
{

	// ׳ Ʈ ϳ ä-_- ѷ    ʰ д.;
	D3DXVECTOR2 Scaling = _Scaling, RCenter = _RCenter, Trans( x, y );

//	return m_pBitmap->Draw( m_pTexture, pSrcRect, &Scaling, 
//		&RCenter, Angle, &Trans, 0xFFFFFFFF );

//	return m_pBitmap->Draw( m_pTexture, pSrcRect, &RCenter, &Trans, 0xFFFFFFFF );
	return S_OK;
}


// Լ ̸ : CSBitmap::Draw
// Լ  : Ʈ Ŭ  ִ ƾ. -_-+
// ȯ  : HRESULT 
//       : RECT* pSrcRect
//       : float x
//       : float y
//       : float Angle
//       : D3DXVECTOR2 _RCenter
//       : DWORD dwFlip			μ  ä
//		 : D3DCOLOR Alpha		ĺ  ÷ 
//    ۼ : `Star.-  ( 2002-06-02  8:42:26 )
HRESULT CSBitmap::Draw( RECT* pSrcRect, float x, float y, float Angle, D3DXVECTOR3 _RCenter,
					    DWORD dwFlip, D3DCOLOR Alpha )
{
//	D3DXVECTOR2 Scaling = m_vScaling, RCenter = _RCenter, Trans( x, y );
	D3DXVECTOR2 Scaling = D3DXVECTOR2( 1, 1 );
	D3DXVECTOR3 RCenter = _RCenter, Trans( x, y, 0.0f );


	if( dwFlip & VFLIP )
	{
        Trans.x = Trans.x + (float)( pSrcRect->right - pSrcRect->left );
        Scaling.x = -Scaling.x;	
	}
	if( dwFlip & HFLIP )
	{
        Trans.y = Trans.y + (float)( pSrcRect->bottom - pSrcRect->top );
        Scaling.y = -Scaling.y;	
	}

//	return m_pBitmap->Draw( m_pTexture, pSrcRect, &Scaling, 
//		&RCenter, Angle, &Trans, Alpha );
	return m_pBitmap->Draw( m_pTexture, pSrcRect, &RCenter, &Trans, Alpha );

//	return S_OK;
}


void CSBitmap::Begin()
{
	m_pBitmap->Begin(0);
}

void CSBitmap::End()
{
	m_pBitmap->End();
}

void CSBitmap::Release()
{
	if( m_pTexture )
	{
		m_pTexture->Release();
		m_pTexture = NULL;
	}

	if( m_pBitmap )
	{
		m_pBitmap->Release();
		m_pBitmap = NULL;
	}
}

